/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * RadicalInfoPanel.java
 *
 * Created on 21-nov-2010, 13:26:36
 */

package net.ajaest.jdk.gui.auxi;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;

import net.ajaest.jdk.core.main.Messages;
import net.ajaest.jdk.core.winHandlers.KanjiInfoWH;
import net.ajaest.jdk.data.auxi.KanjiEnums.RadicalTypeEnum;
import net.ajaest.jdk.data.kanji.Kanji;
import net.ajaest.jdk.data.kanji.RadicalVariant;
import net.ajaest.jdk.data.kanji.RadicalVariantTag;


/**
 *
 * @author ajaest10
 */
public class RadicalInfoPanel extends javax.swing.JPanel {

	private static final long serialVersionUID = -2856458921233757501L;

	private Boolean romanized;
    private RadicalVariantTag radical;
    private KanjiInfoWH kiwe;

    /** Creates new form RadicalInfoPanel */
    public RadicalInfoPanel(KanjiInfoWH kiwe, RadicalVariantTag rad, Boolean romanized) {

		this.kiwe = kiwe;
        this.romanized = romanized;
        this.radical = rad;
        this.romanized = romanized;

        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        RadicalLiteralPanel = new javax.swing.JPanel();
        RadicalLiteralLabel = new javax.swing.JLabel();
        RadicalPanel = new javax.swing.JPanel();
        NumberTitlePanel = new javax.swing.JPanel();
        NumberTitleLabel = new javax.swing.JLabel();
        NumberPanel = new javax.swing.JPanel();
        NumberLabel = new javax.swing.JLabel();
        TypeTitlePanel = new javax.swing.JPanel();
        TypeTitleLabel = new javax.swing.JLabel();
        TypePanel = new javax.swing.JPanel();
        TypeLabel = new javax.swing.JLabel();
        NamesTitlePanel = new javax.swing.JPanel();
        NamesTitleLabel = new javax.swing.JLabel();
        NamesPanel = new javax.swing.JPanel();
        NamesLabel = new javax.swing.JLabel();
        UnicodeTitlePanel = new javax.swing.JPanel();
        UnicodeTitleLabel = new javax.swing.JLabel();
        UnicodePanel = new javax.swing.JPanel();
        UnicodeLabel = new javax.swing.JLabel();
        UnicodeNameTitlePanel = new javax.swing.JPanel();
        UnicodeNameTitleLabel = new javax.swing.JLabel();
        UnicodeNamePanel = new javax.swing.JPanel();
        UnicodeNameLabel = new javax.swing.JLabel();
        KangxiTitlePanel = new javax.swing.JPanel();
        KangxiTitleLabel = new javax.swing.JLabel();
        KangxiPanel = new javax.swing.JPanel();
        KangxiLabel = new javax.swing.JLabel();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        setPreferredSize(new java.awt.Dimension(200, 457));

        RadicalLiteralPanel.setBackground(new java.awt.Color(254, 254, 254));
        RadicalLiteralPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        RadicalLiteralPanel.setPreferredSize(new java.awt.Dimension(114, 114));
        RadicalLiteralPanel.setLayout(new java.awt.BorderLayout());

        RadicalLiteralLabel.setFont(kiwe.getUnicodeFont().deriveFont((float)90));
        RadicalLiteralLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        RadicalLiteralLabel.setText(getRadicalLiteral());
        RadicalLiteralLabel.setAlignmentY(0.0F);
        RadicalLiteralLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        RadicalLiteralLabel.setMaximumSize(new java.awt.Dimension(80, 80));
        RadicalLiteralPanel.add(RadicalLiteralLabel, java.awt.BorderLayout.CENTER);
        kiwe.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(RadicalLiteralLabel);

        RadicalPanel.setBorder(null);
        RadicalPanel.setPreferredSize(new java.awt.Dimension(80, 491));

        NumberTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        NumberTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        NumberTitleLabel.setText(kiwe.getMessage(Messages.PANELRADICALINFO_radicalNumber));

        javax.swing.GroupLayout NumberTitlePanelLayout = new javax.swing.GroupLayout(NumberTitlePanel);
        NumberTitlePanel.setLayout(NumberTitlePanelLayout);
        NumberTitlePanelLayout.setHorizontalGroup(
            NumberTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NumberTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        NumberTitlePanelLayout.setVerticalGroup(
            NumberTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NumberTitleLabel)
        );

        NumberLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        NumberLabel.setText(getRadicalNumberString());
        kiwe.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(NumberLabel);

        javax.swing.GroupLayout NumberPanelLayout = new javax.swing.GroupLayout(NumberPanel);
        NumberPanel.setLayout(NumberPanelLayout);
        NumberPanelLayout.setHorizontalGroup(
            NumberPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NumberLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        NumberPanelLayout.setVerticalGroup(
            NumberPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NumberLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 40, Short.MAX_VALUE)
        );

        TypeTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        TypeTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        TypeTitleLabel.setText(kiwe.getMessage(Messages.PANELRADICALINFO_radicalType));

        javax.swing.GroupLayout TypeTitlePanelLayout = new javax.swing.GroupLayout(TypeTitlePanel);
        TypeTitlePanel.setLayout(TypeTitlePanelLayout);
        TypeTitlePanelLayout.setHorizontalGroup(
            TypeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(TypeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        TypeTitlePanelLayout.setVerticalGroup(
            TypeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(TypeTitleLabel)
        );

        TypeLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        TypeLabel.setText(getRadicalTypeString());
        kiwe.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(TypeLabel);

        javax.swing.GroupLayout TypePanelLayout = new javax.swing.GroupLayout(TypePanel);
        TypePanel.setLayout(TypePanelLayout);
        TypePanelLayout.setHorizontalGroup(
            TypePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(TypeLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        TypePanelLayout.setVerticalGroup(
            TypePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(TypeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 40, Short.MAX_VALUE)
        );

        NamesTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        NamesTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        NamesTitleLabel.setText(kiwe.getMessage(Messages.PANELRADICALINFO_radicalNames));

        javax.swing.GroupLayout NamesTitlePanelLayout = new javax.swing.GroupLayout(NamesTitlePanel);
        NamesTitlePanel.setLayout(NamesTitlePanelLayout);
        NamesTitlePanelLayout.setHorizontalGroup(
            NamesTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NamesTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        NamesTitlePanelLayout.setVerticalGroup(
            NamesTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NamesTitleLabel)
        );

        NamesLabel.setFont(kiwe.getUnicodeFont());
        NamesLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        NamesLabel.setText(getRadicalNameString());
        kiwe.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(NamesLabel);

        javax.swing.GroupLayout NamesPanelLayout = new javax.swing.GroupLayout(NamesPanel);
        NamesPanel.setLayout(NamesPanelLayout);
        NamesPanelLayout.setHorizontalGroup(
            NamesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NamesLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        NamesPanelLayout.setVerticalGroup(
            NamesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(NamesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(NamesLabel)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        UnicodeTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        UnicodeTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        UnicodeTitleLabel.setText(kiwe.getMessage(Messages.PANELRADICALINFO_radicalUnicode));

        javax.swing.GroupLayout UnicodeTitlePanelLayout = new javax.swing.GroupLayout(UnicodeTitlePanel);
        UnicodeTitlePanel.setLayout(UnicodeTitlePanelLayout);
        UnicodeTitlePanelLayout.setHorizontalGroup(
            UnicodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        UnicodeTitlePanelLayout.setVerticalGroup(
            UnicodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeTitleLabel)
        );

        UnicodeLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        UnicodeLabel.setText(getRadicalUnicodeString());
        kiwe.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(UnicodeLabel);

        javax.swing.GroupLayout UnicodePanelLayout = new javax.swing.GroupLayout(UnicodePanel);
        UnicodePanel.setLayout(UnicodePanelLayout);
        UnicodePanelLayout.setHorizontalGroup(
            UnicodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        UnicodePanelLayout.setVerticalGroup(
            UnicodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 40, Short.MAX_VALUE)
        );

        UnicodeNameTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        UnicodeNameTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        UnicodeNameTitleLabel.setText(kiwe.getMessage(Messages.PANELRADICALINFO_radicalUnicodeName));

        javax.swing.GroupLayout UnicodeNameTitlePanelLayout = new javax.swing.GroupLayout(UnicodeNameTitlePanel);
        UnicodeNameTitlePanel.setLayout(UnicodeNameTitlePanelLayout);
        UnicodeNameTitlePanelLayout.setHorizontalGroup(
            UnicodeNameTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeNameTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        UnicodeNameTitlePanelLayout.setVerticalGroup(
            UnicodeNameTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeNameTitleLabel)
        );

        UnicodeNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        UnicodeNameLabel.setText(getRadicalUnicodeNameString());
        kiwe.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(UnicodeNameLabel);

        javax.swing.GroupLayout UnicodeNamePanelLayout = new javax.swing.GroupLayout(UnicodeNamePanel);
        UnicodeNamePanel.setLayout(UnicodeNamePanelLayout);
        UnicodeNamePanelLayout.setHorizontalGroup(
            UnicodeNamePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeNameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        UnicodeNamePanelLayout.setVerticalGroup(
            UnicodeNamePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeNameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 40, Short.MAX_VALUE)
        );

        KangxiTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        KangxiTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        KangxiTitleLabel.setText(kiwe.getMessage(Messages.PANELRADICALINFO_radicalKangxi));

        javax.swing.GroupLayout KangxiTitlePanelLayout = new javax.swing.GroupLayout(KangxiTitlePanel);
        KangxiTitlePanel.setLayout(KangxiTitlePanelLayout);
        KangxiTitlePanelLayout.setHorizontalGroup(
            KangxiTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(KangxiTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        KangxiTitlePanelLayout.setVerticalGroup(
            KangxiTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(KangxiTitleLabel)
        );

        KangxiLabel.setFont(kiwe.getUnicodeFont());
        KangxiLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        KangxiLabel.setText(getRadicalUnicodeKangxiString());
        kiwe.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(KangxiLabel);

        javax.swing.GroupLayout KangxiPanelLayout = new javax.swing.GroupLayout(KangxiPanel);
        KangxiPanel.setLayout(KangxiPanelLayout);
        KangxiPanelLayout.setHorizontalGroup(
            KangxiPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(KangxiLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        KangxiPanelLayout.setVerticalGroup(
            KangxiPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(KangxiLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 40, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout RadicalPanelLayout = new javax.swing.GroupLayout(RadicalPanel);
        RadicalPanel.setLayout(RadicalPanelLayout);
        RadicalPanelLayout.setHorizontalGroup(
            RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 194, Short.MAX_VALUE)
            .addGroup(RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(RadicalPanelLayout.createSequentialGroup()
                    .addGap(0, 0, 0)
                    .addGroup(RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(TypeTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(NumberPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(NumberTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(TypePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(NamesTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(NamesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(UnicodeTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(UnicodePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(UnicodeNameTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(UnicodeNamePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(KangxiTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(KangxiPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGap(0, 0, 0)))
        );
        RadicalPanelLayout.setVerticalGroup(
            RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 337, Short.MAX_VALUE)
            .addGroup(RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(RadicalPanelLayout.createSequentialGroup()
                    .addGap(0, 0, 0)
                    .addComponent(NumberTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(NumberPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(TypeTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(TypePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(NamesTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(NamesPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(UnicodeTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(UnicodePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(UnicodeNameTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(UnicodeNamePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(KangxiTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(KangxiPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(RadicalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
            .addComponent(RadicalLiteralPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(RadicalLiteralPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(0, 0, 0)
                .addComponent(RadicalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents


	private String getRadicalTypeString() {

		String st = null;

		if (radical.getRadicalType() != null) {
			st = kiwe.getMessage("RADICAL_TYPE_" + radical.getRadicalType().toString());
		} else {
			st = "--";
		}

		return st;
	}

	private String getRadicalLiteral() {

		String st = null;

		if (radical.getUnicode() != null) {
			st = new String(Character.toChars(radical.getUnicode()));
		} else {
			st = "?";
		}

		return st;
	}

	private String getRadicalUnicodeKangxiString() {

		String st = null;

		if (radical.getKangxiUnicode() != null) {

			st = new String(Character.toChars(radical.getKangxiUnicode()));
			st += " -- " + String.format("%x", radical.getKangxiUnicode()).toUpperCase();
		} else {
			st = "--";
		}

		return st;
	}

	private String getRadicalUnicodeNameString() {

		String st = null;

		if (radical.getUnicodeName() != null) {

			st = radical.getUnicodeName();
		} else {
			st = "--";
		}

		return st;
	}

	private String getRadicalUnicodeString() {

		String st = null;

		if (radical.getUnicode() != null) {

			st = String.format("%x", radical.getUnicode()).toUpperCase();
		} else {
			st = "--";
		}

		return st;
	}

	private String getRadicalNameString() {

		StringBuilder st = null;

		if (radical.getNames() != null || radical.getNames().size() > 0) {

			st = new StringBuilder();// "<html><body><center>");
			
			for(String s : radical.getNames()){
				if (!romanized)
					st.append(s);// + "<br>");
				else
					st.append(Kanji.kanaToRomaji(s));// + "<br>");
				// TODO: show all names
				break;
				// -----
			}
			
			st.append("");// </center></body></html>");;
		} else {
			st = new StringBuilder("--");
		}

		return st.toString();
	}

	private String getRadicalNumberString() {

		StringBuilder st = null;

		if (radical.getNumber() != null) {

			st = new StringBuilder();

			st.append(radical.getNumber());

			if (radical.getAuxNumber() != null)
				st.append("." + radical.getAuxNumber());
		} else {
			st = new StringBuilder("--");
		}

		return st.toString();
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel KangxiLabel;
    private javax.swing.JPanel KangxiPanel;
    private javax.swing.JLabel KangxiTitleLabel;
    private javax.swing.JPanel KangxiTitlePanel;
    private javax.swing.JLabel NamesLabel;
    private javax.swing.JPanel NamesPanel;
    private javax.swing.JLabel NamesTitleLabel;
    private javax.swing.JPanel NamesTitlePanel;
    private javax.swing.JLabel NumberLabel;
    private javax.swing.JPanel NumberPanel;
    private javax.swing.JLabel NumberTitleLabel;
    private javax.swing.JPanel NumberTitlePanel;
    private javax.swing.JLabel RadicalLiteralLabel;
    private javax.swing.JPanel RadicalLiteralPanel;
    private javax.swing.JPanel RadicalPanel;
    private javax.swing.JLabel TypeLabel;
    private javax.swing.JPanel TypePanel;
    private javax.swing.JLabel TypeTitleLabel;
    private javax.swing.JPanel TypeTitlePanel;
    private javax.swing.JLabel UnicodeLabel;
    private javax.swing.JLabel UnicodeNameLabel;
    private javax.swing.JPanel UnicodeNamePanel;
    private javax.swing.JLabel UnicodeNameTitleLabel;
    private javax.swing.JPanel UnicodeNameTitlePanel;
    private javax.swing.JPanel UnicodePanel;
    private javax.swing.JLabel UnicodeTitleLabel;
    private javax.swing.JPanel UnicodeTitlePanel;
    // End of variables declaration//GEN-END:variables

	public static void main(String... args) {

		System.out.println(Messages.get(Messages.PANELRADICALINFO_radicalNumber));
		RadicalVariant r = new RadicalVariant(9);
		r.setAuxNumber(2);
		r.setRadicalType(RadicalTypeEnum.left);
		List<String> names = new ArrayList<String>();
		names.add("ひと");
		names.add("テスト");
		r.setNames(names);
		r.setUnicode(0x4EBB);
		r.setUnicodeName("Person");
		r.setKangxiUnicode(0x2E85);

		JFrame jf = new JFrame();
		jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		jf.add(new RadicalInfoPanel(new KanjiInfoWH(null), r, true));
		jf.setVisible(true);
	}
}
