/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * InfoDialog.java
 *
 * Created on 05-dic-2010, 22:48:54
 */

package net.ajaest.jdk.gui.dialogs;

import java.awt.Desktop;

import javax.swing.JScrollPane;
import javax.swing.event.HyperlinkEvent;

import net.ajaest.jdk.core.main.Messages;
import net.ajaest.jdk.core.winHandlers.InfoDialogsEngine;

/**
 * 
 * @author ajaest10
 */
public class InfoDialog extends javax.swing.JDialog {

	private static final long serialVersionUID = -41630311448775581L;

	private InfoDialogsEngine ide;
	private String message;
	private String title;

	/** Creates new form InfoDialog */
	public InfoDialog(java.awt.Frame parent, boolean modal, InfoDialogsEngine ide, String title, String message) {
		super(parent, modal);

		this.message = "<html><div id=\"centeredcontent\"><p>" + message.replace("<html>", "").replace("</html>", "") + "</p></div>";
		this.title = title;
		this.ide = ide;

		initComponents();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	// <editor-fold defaultstate="collapsed"
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        MessageScrollPanel = new javax.swing.JScrollPane();
        MessageLabel = new javax.swing.JEditorPane();
        AcceptButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(title);
        setFont(ide.getUnicodeFont());

        MessageScrollPanel.setBorder(null);
        MessageScrollPanel.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        MessageScrollPanel.setViewportBorder(null);
        MessageScrollPanel.setOpaque(false);
        MessageScrollPanel.getViewport().setOpaque(false);

        MessageLabel.setBorder(null);
        MessageLabel.setContentType("text/html");
        MessageLabel.setEditable(false);
        //In order to use "setFont()" font
        MessageLabel.putClientProperty(javax.swing.JEditorPane.HONOR_DISPLAY_PROPERTIES, Boolean.TRUE);
        MessageLabel.setFont(ide.getUnicodeFont());
        MessageLabel.setText(message);
        MessageLabel.setOpaque(false);
        MessageLabel.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
            public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {
                MessageLabelHyperlinkUpdate(evt);
            }
        });
        MessageScrollPanel.setViewportView(MessageLabel);

        AcceptButton.setText(ide.getMessage(Messages.INFODIALOG_buttonAccept));
        AcceptButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AcceptButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(MessageScrollPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 291, Short.MAX_VALUE)
                    .addComponent(AcceptButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 291, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(MessageScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 76, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(AcceptButton)
                .addContainerGap())
        );

        MessageLabel.setCaretPosition(0);

        pack();
    }// </editor-fold>//GEN-END:initComponents

	private void AcceptButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_AcceptButtonActionPerformed
		ide.AcceptButtonPressed();
	}// GEN-LAST:event_AcceptButtonActionPerformed

	private void MessageLabelHyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {// GEN-FIRST:event_MessageLabelHyperlinkUpdate
		JDKInfoLabelHyperlinkUpdate(evt);
	}// GEN-LAST:event_MessageLabelHyperlinkUpdate

	private void JDKInfoLabelHyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {
		if (HyperlinkEvent.EventType.ACTIVATED.equals(evt.getEventType())) {
			if (Desktop.isDesktopSupported()) {
				Desktop desktop = Desktop.getDesktop();
				try {
					desktop.browse(evt.getURL().toURI());
				} catch (Exception e) {
				}
			}
		}
	}
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton AcceptButton;
    private javax.swing.JEditorPane MessageLabel;
    private javax.swing.JScrollPane MessageScrollPanel;
    // End of variables declaration//GEN-END:variables

	public JScrollPane __getMessageScrollPanel() {
		return MessageScrollPanel;
	}
}
