//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

/*
 * AboutWindow.java
 *
 * Created on 06-dic-2010, 12:14:23
 */

package net.ajaest.jdk.gui.windows;

import java.awt.Desktop;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.event.HyperlinkEvent;

import net.ajaest.jdk.core.winHandlers.AboutWH;

//TODO: javadoc
public class AboutWindow extends javax.swing.JDialog {

	private static final long serialVersionUID = 1490062401660504740L;
	private AboutWH awh;

    /** Creates new form AboutWindow */
    public AboutWindow(AboutWH awh,java.awt.Frame parent, boolean modal) {
        super(parent, modal) ;
        this.awh = awh;
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        MainInfoPanel = new javax.swing.JPanel();
        JDKInfoLabel = new javax.swing.JEditorPane();
        JDKLogo = new javax.swing.JPanel();
        LicensesPanel = new javax.swing.JPanel();
        LicensesSrollPane = new javax.swing.JScrollPane();
        LicensesLabel = new javax.swing.JEditorPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(awh.getTitleString());

        MainInfoPanel.setBorder(null);

        JDKInfoLabel.setBorder(null);
        JDKInfoLabel.setContentType("text/html");
        JDKInfoLabel.setEditable(false);
        JDKInfoLabel.setText(awh.getJDKInfoString());
        JDKInfoLabel.setOpaque(false);
        JDKInfoLabel.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
            public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {
                JDKInfoLabelHyperlinkUpdate(evt);
            }
        });

        JDKLogo.setBorder(null);
        JDKLogo.setPreferredSize(new java.awt.Dimension(112, 112));
        JDKLogo.setLayout(new java.awt.BorderLayout());
        JLabel backgroundImage = new JLabel(new ImageIcon(this.getClass().getResource("/images/3.0_128.png")));
        JDKLogo.add(backgroundImage);

        javax.swing.GroupLayout MainInfoPanelLayout = new javax.swing.GroupLayout(MainInfoPanel);
        MainInfoPanel.setLayout(MainInfoPanelLayout);
        MainInfoPanelLayout.setHorizontalGroup(
            MainInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(MainInfoPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JDKInfoLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 425, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JDKLogo, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(27, Short.MAX_VALUE))
        );
        MainInfoPanelLayout.setVerticalGroup(
            MainInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, MainInfoPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(MainInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(JDKLogo, javax.swing.GroupLayout.DEFAULT_SIZE, 128, Short.MAX_VALUE)
                    .addComponent(JDKInfoLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 128, Short.MAX_VALUE))
                .addContainerGap())
        );

        LicensesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(awh.getLicenseBorderString()));

        LicensesSrollPane.setBorder(null);
        LicensesSrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        LicensesSrollPane.setViewportBorder(null);
        LicensesSrollPane.setOpaque(false);
        LicensesSrollPane.getViewport().setOpaque(false);

        LicensesLabel.setBorder(null);
        LicensesLabel.setContentType("text/html");
        LicensesLabel.setEditable(false);
        LicensesLabel.setText(awh.getLicenseInfoString());
        LicensesLabel.setOpaque(false);
        LicensesLabel.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
            public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {
                LicensesLabelHyperlinkUpdate(evt);
            }
        });
        LicensesSrollPane.setViewportView(LicensesLabel);

        javax.swing.GroupLayout LicensesPanelLayout = new javax.swing.GroupLayout(LicensesPanel);
        LicensesPanel.setLayout(LicensesPanelLayout);
        LicensesPanelLayout.setHorizontalGroup(
            LicensesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LicensesSrollPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 586, Short.MAX_VALUE)
        );
        LicensesPanelLayout.setVerticalGroup(
            LicensesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LicensesSrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 260, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(LicensesPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(MainInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(MainInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(LicensesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        LicensesLabel.setCaretPosition(0);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-630)/2, (screenSize.height-503)/2, 630, 503);
    }// </editor-fold>//GEN-END:initComponents

    private void JDKInfoLabelHyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {//GEN-FIRST:event_JDKInfoLabelHyperlinkUpdate
        if (HyperlinkEvent.EventType.ACTIVATED.equals(evt.getEventType())){
            if (Desktop.isDesktopSupported()) {
			Desktop desktop = Desktop.getDesktop();
			try {
				desktop.browse(evt.getURL().toURI());
			} catch (Exception e) {}
		} 
        }
    }//GEN-LAST:event_JDKInfoLabelHyperlinkUpdate

    private void LicensesLabelHyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {//GEN-FIRST:event_LicensesLabelHyperlinkUpdate
        JDKInfoLabelHyperlinkUpdate(evt);
    }//GEN-LAST:event_LicensesLabelHyperlinkUpdate


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JEditorPane JDKInfoLabel;
    private javax.swing.JPanel JDKLogo;
    private javax.swing.JEditorPane LicensesLabel;
    private javax.swing.JPanel LicensesPanel;
    private javax.swing.JScrollPane LicensesSrollPane;
    private javax.swing.JPanel MainInfoPanel;
    // End of variables declaration//GEN-END:variables

}
