//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

/*
 * KanjiInfoExtWindow.java
 *
 * Created on 23-nov-2010, 11:17:23
 */

package net.ajaest.jdk.gui.windows;

import net.ajaest.jdk.core.main.Messages;
import net.ajaest.jdk.core.winHandlers.KanjiInfoWH;
import net.ajaest.jdk.data.kanji.KanjiTag;
import net.ajaest.jdk.gui.auxi.JPanelFactory;
import net.ajaest.jdk.gui.auxi.KanjiInfoWindow;

// TODO: javadoc
public class KanjiInfoExtWindow extends KanjiInfoWindow {

	private static final long serialVersionUID = -4818000290413214901L;

	public KanjiInfoExtWindow(KanjiInfoWH kimwh, KanjiTag kt, boolean romanized) {
		super(kimwh, kt, romanized);
		initComponents();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	// <editor-fold defaultstate="collapsed"
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ExtendedKanjiInfoPanel = new javax.swing.JPanel();
        KanjiLiteralPanel = new javax.swing.JPanel();
        StrokeButton = new javax.swing.JButton();
        KanjiLiteralLabel = new javax.swing.JLabel();
        KanjiInfoPanel = new javax.swing.JPanel();
        RadicalTitle = new javax.swing.JPanel();
        RadicalTitleLabel = new javax.swing.JLabel();
        RadicalPanel = new javax.swing.JPanel();
        RadicalLabel = new javax.swing.JLabel();
        RadicalMoreInfoButton = new javax.swing.JButton();
        StrokeCountTitlePanel = new javax.swing.JPanel();
        StrokeCountTitleLabel = new javax.swing.JLabel();
        StrokeCountPanel = new javax.swing.JPanel();
        StrokeCountLabel = new javax.swing.JLabel();
        GradeTitlePanel = new javax.swing.JPanel();
        GradeTitleLabel = new javax.swing.JLabel();
        GradePanel = new javax.swing.JPanel();
        GradeLabel = new javax.swing.JLabel();
        KanjiMeaningPanel = new javax.swing.JPanel();
        MeaningsTitlePanel = new javax.swing.JPanel();
        MeaningsTitleLabel = new javax.swing.JLabel();
        MeaningsScrollPane = new javax.swing.JScrollPane();
        MeaningsList = new javax.swing.JList();
        KanjiReadingsPanel = new javax.swing.JPanel();
        ReadingsTitlePanel = new javax.swing.JPanel();
        ReadingsTitleLabel = new javax.swing.JLabel();
        ReadingsPanel = new javax.swing.JPanel();
        VariantQueryPanel = new javax.swing.JPanel();
        VariantsTitlePanel = new javax.swing.JPanel();
        VariantsTitleLabel = new javax.swing.JLabel();
        VariantsPanel = new javax.swing.JPanel();
        VariantsScrollPane = new javax.swing.JScrollPane();
        VariantsList = new javax.swing.JList();
        QueryTitlePanel = new javax.swing.JPanel();
        QueryTitleLabel = new javax.swing.JLabel();
        QueryPanel = new javax.swing.JPanel();
        SkipCodeTitlePanel = new javax.swing.JPanel();
        SkipCodeTitleLabel = new javax.swing.JLabel();
        SkipCodePanel = new javax.swing.JPanel();
        SkipCodeLabel = new javax.swing.JLabel();
        SpahnHadamitzkyTitlePanel = new javax.swing.JPanel();
        SpahnHadamiztkyTitleLabel = new javax.swing.JLabel();
        SpahnHadamitzkyPanel = new javax.swing.JPanel();
        SpahnHadamiztkyLabel = new javax.swing.JLabel();
        FourCornerTitlePanel = new javax.swing.JPanel();
        FourCornerTitleLabel = new javax.swing.JLabel();
        FourCornerPanel = new javax.swing.JPanel();
        FourCornerLabel = new javax.swing.JLabel();
        DeRooTitlePanel = new javax.swing.JPanel();
        DeRooTitleLabel = new javax.swing.JLabel();
        DeRooPanel = new javax.swing.JPanel();
        DeRooLabel = new javax.swing.JLabel();
        ExtraInfoPanel = new javax.swing.JPanel();
        JLPTLevelTitlePanel = new javax.swing.JPanel();
        JLPTLevelTitleLabel = new javax.swing.JLabel();
        FrequencyTitlePanel = new javax.swing.JPanel();
        FrequencyTitleLabel = new javax.swing.JLabel();
        NelsonRadicalTitlePanel = new javax.swing.JPanel();
        NelsonRadicalTitleLabel = new javax.swing.JLabel();
        JLPTLevelLabel = new javax.swing.JLabel();
        FrequencyLabel = new javax.swing.JLabel();
        NelsonRadicalLabel = new javax.swing.JLabel();
        UnicodeTitlePanel = new javax.swing.JPanel();
        UnicodeTitleLabel = new javax.swing.JLabel();
        UnicodeLabel = new javax.swing.JLabel();
        JisCodeTitlePanel = new javax.swing.JPanel();
        JisCodeTitleLabel = new javax.swing.JLabel();
        JisCodePanel = new javax.swing.JPanel();
        JisCharsetLabel = new javax.swing.JLabel();
        JisCodelabel = new javax.swing.JLabel();
        DicReferencesPanel = new javax.swing.JPanel();
        DicReferencesTitlePanel = new javax.swing.JPanel();
        DicReferencesTitleLabel = new javax.swing.JLabel();
        DicReferencesScrollPane = new javax.swing.JScrollPane();
        DicReferencesList = new javax.swing.JList();
        GraphPanel = new javax.swing.JPanel();
        GraphTitlePanel = new javax.swing.JPanel();
        GraphTitleLabel = new javax.swing.JLabel();
        GraphLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(String.format(Messages.get(Messages.WINKANJIINFO_name), kt.toString()));
        setIconImages(super.getIcons());
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        ExtendedKanjiInfoPanel.setBackground(new java.awt.Color(122, 159, 168));
        ExtendedKanjiInfoPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));

        KanjiLiteralPanel.setBackground(new java.awt.Color(254, 254, 254));
        KanjiLiteralPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        KanjiLiteralPanel.setLayout(null);

        StrokeButton.setFont(kimwh.getUnicodeFont().deriveFont(9f));
        StrokeButton.setText("S");
        StrokeButton.setAlignmentY(0.0F);
        StrokeButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        StrokeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StrokeButtonActionPerformed(evt);
            }
        });
        KanjiLiteralPanel.add(StrokeButton);
        StrokeButton.setBounds(116, 104, 20, 20);
        if(!kimwh.hasStrokeOrder(kt.getUnicodeRef()))
        StrokeButton.setEnabled(false);

        KanjiLiteralLabel.setFont(kimwh.getUnicodeFont().deriveFont((float)90));
        KanjiLiteralLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        KanjiLiteralLabel.setText(kt.toString());
        KanjiLiteralLabel.setAlignmentY(0.0F);
        KanjiLiteralLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        KanjiLiteralLabel.setMaximumSize(new java.awt.Dimension(80, 80));
        KanjiLiteralPanel.add(KanjiLiteralLabel);
        KanjiLiteralLabel.setBounds(3, 3, 136, 120);
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(KanjiLiteralLabel);

        KanjiInfoPanel.setBackground(new java.awt.Color(254, 254, 254));
        KanjiInfoPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        KanjiInfoPanel.setPreferredSize(new java.awt.Dimension(104, 104));

        RadicalTitle.setBackground(new java.awt.Color(145, 145, 145));

        RadicalTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        RadicalTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Radical));
        RadicalTitleLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout RadicalTitleLayout = new javax.swing.GroupLayout(RadicalTitle);
        RadicalTitle.setLayout(RadicalTitleLayout);
        RadicalTitleLayout.setHorizontalGroup(
            RadicalTitleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(RadicalTitleLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        RadicalTitleLayout.setVerticalGroup(
            RadicalTitleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(RadicalTitleLabel)
        );

        RadicalLabel.setFont(kimwh.getUnicodeFont());
        RadicalLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        RadicalLabel.setText(kimwh.getRadicalString(kt.getClassicRadical()));
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(RadicalLabel);

        RadicalMoreInfoButton.setFont(kimwh.getUnicodeFont().deriveFont(10f));
        RadicalMoreInfoButton.setText("+");
        RadicalMoreInfoButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        RadicalMoreInfoButton.setMaximumSize(new java.awt.Dimension(23, 23));
        RadicalMoreInfoButton.setMinimumSize(new java.awt.Dimension(23, 23));
        RadicalMoreInfoButton.setPreferredSize(new java.awt.Dimension(23, 23));
        RadicalMoreInfoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadicalMoreInfoButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout RadicalPanelLayout = new javax.swing.GroupLayout(RadicalPanel);
        RadicalPanel.setLayout(RadicalPanelLayout);
        RadicalPanelLayout.setHorizontalGroup(
            RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, RadicalPanelLayout.createSequentialGroup()
                .addGap(47, 47, 47)
                .addComponent(RadicalLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(RadicalMoreInfoButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        RadicalPanelLayout.setVerticalGroup(
            RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(RadicalPanelLayout.createSequentialGroup()
                .addGroup(RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RadicalLabel)
                    .addComponent(RadicalMoreInfoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 17, Short.MAX_VALUE))
                .addGap(0, 0, 0))
        );

        StrokeCountTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        StrokeCountTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        StrokeCountTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_StrokeCount));
        StrokeCountTitleLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout StrokeCountTitlePanelLayout = new javax.swing.GroupLayout(StrokeCountTitlePanel);
        StrokeCountTitlePanel.setLayout(StrokeCountTitlePanelLayout);
        StrokeCountTitlePanelLayout.setHorizontalGroup(
            StrokeCountTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        StrokeCountTitlePanelLayout.setVerticalGroup(
            StrokeCountTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountTitleLabel)
        );

        StrokeCountLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        StrokeCountLabel.setText(getStrokeCountString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(StrokeCountLabel);

        javax.swing.GroupLayout StrokeCountPanelLayout = new javax.swing.GroupLayout(StrokeCountPanel);
        StrokeCountPanel.setLayout(StrokeCountPanelLayout);
        StrokeCountPanelLayout.setHorizontalGroup(
            StrokeCountPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        StrokeCountPanelLayout.setVerticalGroup(
            StrokeCountPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountLabel)
        );

        GradeTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        GradeTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        GradeTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Grade));

        javax.swing.GroupLayout GradeTitlePanelLayout = new javax.swing.GroupLayout(GradeTitlePanel);
        GradeTitlePanel.setLayout(GradeTitlePanelLayout);
        GradeTitlePanelLayout.setHorizontalGroup(
            GradeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GradeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        GradeTitlePanelLayout.setVerticalGroup(
            GradeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GradeTitleLabel)
        );

        GradeLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        GradeLabel.setText(getGradeString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(GradeLabel);

        javax.swing.GroupLayout GradePanelLayout = new javax.swing.GroupLayout(GradePanel);
        GradePanel.setLayout(GradePanelLayout);
        GradePanelLayout.setHorizontalGroup(
            GradePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GradeLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        GradePanelLayout.setVerticalGroup(
            GradePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GradeLabel)
        );

        javax.swing.GroupLayout KanjiInfoPanelLayout = new javax.swing.GroupLayout(KanjiInfoPanel);
        KanjiInfoPanel.setLayout(KanjiInfoPanelLayout);
        KanjiInfoPanelLayout.setHorizontalGroup(
            KanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(GradeTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(RadicalTitle, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(RadicalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
            .addComponent(StrokeCountPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(GradePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        KanjiInfoPanelLayout.setVerticalGroup(
            KanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(KanjiInfoPanelLayout.createSequentialGroup()
                .addComponent(RadicalTitle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(RadicalPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(StrokeCountTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(StrokeCountPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(GradeTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(GradePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        KanjiMeaningPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));

        MeaningsTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        MeaningsTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        MeaningsTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Meanings));

        javax.swing.GroupLayout MeaningsTitlePanelLayout = new javax.swing.GroupLayout(MeaningsTitlePanel);
        MeaningsTitlePanel.setLayout(MeaningsTitlePanelLayout);
        MeaningsTitlePanelLayout.setHorizontalGroup(
            MeaningsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(MeaningsTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
        );
        MeaningsTitlePanelLayout.setVerticalGroup(
            MeaningsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(MeaningsTitleLabel)
        );

        MeaningsList.setBackground(new java.awt.Color(237, 236, 235));
        MeaningsList.setModel(getMeaningListModel());
        MeaningsScrollPane.setViewportView(MeaningsList);
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(MeaningsList);

        javax.swing.GroupLayout KanjiMeaningPanelLayout = new javax.swing.GroupLayout(KanjiMeaningPanel);
        KanjiMeaningPanel.setLayout(KanjiMeaningPanelLayout);
        KanjiMeaningPanelLayout.setHorizontalGroup(
            KanjiMeaningPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(MeaningsTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(MeaningsScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
        );
        KanjiMeaningPanelLayout.setVerticalGroup(
            KanjiMeaningPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(KanjiMeaningPanelLayout.createSequentialGroup()
                .addComponent(MeaningsTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(MeaningsScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 203, Short.MAX_VALUE))
        );

        KanjiReadingsPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        KanjiReadingsPanel.setPreferredSize(new java.awt.Dimension(204, 40));

        ReadingsTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        ReadingsTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        ReadingsTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Readings));
        ReadingsTitleLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout ReadingsTitlePanelLayout = new javax.swing.GroupLayout(ReadingsTitlePanel);
        ReadingsTitlePanel.setLayout(ReadingsTitlePanelLayout);
        ReadingsTitlePanelLayout.setHorizontalGroup(
            ReadingsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(ReadingsTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 183, Short.MAX_VALUE)
        );
        ReadingsTitlePanelLayout.setVerticalGroup(
            ReadingsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(ReadingsTitleLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        ReadingsPanel.setBackground(new java.awt.Color(0, 255, 0));
        ReadingsPanel.setLayout(new java.awt.BorderLayout());
        ReadingsPanel.add(JPanelFactory.createKanjiReadingsList(kimwh.getUnicodeFont(),kt, true, romanized, kimwh.getJDKGuiEngine().getEditContextMenuEngine()));

        javax.swing.GroupLayout KanjiReadingsPanelLayout = new javax.swing.GroupLayout(KanjiReadingsPanel);
        KanjiReadingsPanel.setLayout(KanjiReadingsPanelLayout);
        KanjiReadingsPanelLayout.setHorizontalGroup(
            KanjiReadingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(ReadingsTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(ReadingsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 183, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        KanjiReadingsPanelLayout.setVerticalGroup(
            KanjiReadingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(KanjiReadingsPanelLayout.createSequentialGroup()
                .addComponent(ReadingsTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(ReadingsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 202, Short.MAX_VALUE))
        );

        VariantQueryPanel.setBackground(new java.awt.Color(0, 255, 0));
        VariantQueryPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));

        VariantsTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        VariantsTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        VariantsTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Variants));

        javax.swing.GroupLayout VariantsTitlePanelLayout = new javax.swing.GroupLayout(VariantsTitlePanel);
        VariantsTitlePanel.setLayout(VariantsTitlePanelLayout);
        VariantsTitlePanelLayout.setHorizontalGroup(
            VariantsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(VariantsTitleLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        VariantsTitlePanelLayout.setVerticalGroup(
            VariantsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(VariantsTitleLabel)
        );

        VariantsPanel.setLayout(new java.awt.BorderLayout());

        VariantsList.setModel(super.getVariantsListModel());
        VariantsScrollPane.setViewportView(VariantsList);
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(VariantsList);

        VariantsPanel.add(VariantsScrollPane, java.awt.BorderLayout.CENTER);

        QueryTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        QueryTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        QueryTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_QueryCodes));

        javax.swing.GroupLayout QueryTitlePanelLayout = new javax.swing.GroupLayout(QueryTitlePanel);
        QueryTitlePanel.setLayout(QueryTitlePanelLayout);
        QueryTitlePanelLayout.setHorizontalGroup(
            QueryTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(QueryTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        QueryTitlePanelLayout.setVerticalGroup(
            QueryTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(QueryTitleLabel)
        );

        QueryPanel.setBackground(new java.awt.Color(0, 255, 0));
        QueryPanel.setLayout(new java.awt.GridLayout(8, 1));

        SkipCodeTitlePanel.setBackground(java.awt.Color.green);

        SkipCodeTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        SkipCodeTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_QueryCodes_SKIP));

        javax.swing.GroupLayout SkipCodeTitlePanelLayout = new javax.swing.GroupLayout(SkipCodeTitlePanel);
        SkipCodeTitlePanel.setLayout(SkipCodeTitlePanelLayout);
        SkipCodeTitlePanelLayout.setHorizontalGroup(
            SkipCodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SkipCodeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        SkipCodeTitlePanelLayout.setVerticalGroup(
            SkipCodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SkipCodeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(SkipCodeTitlePanel);

        SkipCodeLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        SkipCodeLabel.setText(super.getSkipCodeString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(SkipCodeLabel);

        javax.swing.GroupLayout SkipCodePanelLayout = new javax.swing.GroupLayout(SkipCodePanel);
        SkipCodePanel.setLayout(SkipCodePanelLayout);
        SkipCodePanelLayout.setHorizontalGroup(
            SkipCodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SkipCodeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        SkipCodePanelLayout.setVerticalGroup(
            SkipCodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SkipCodeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(SkipCodePanel);

        SpahnHadamitzkyTitlePanel.setBackground(java.awt.Color.orange);

        SpahnHadamiztkyTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        SpahnHadamiztkyTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_QueryCodes_SpahnHadamitzky));

        javax.swing.GroupLayout SpahnHadamitzkyTitlePanelLayout = new javax.swing.GroupLayout(SpahnHadamitzkyTitlePanel);
        SpahnHadamitzkyTitlePanel.setLayout(SpahnHadamitzkyTitlePanelLayout);
        SpahnHadamitzkyTitlePanelLayout.setHorizontalGroup(
            SpahnHadamitzkyTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SpahnHadamiztkyTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        SpahnHadamitzkyTitlePanelLayout.setVerticalGroup(
            SpahnHadamitzkyTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SpahnHadamiztkyTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(SpahnHadamitzkyTitlePanel);

        SpahnHadamiztkyLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        SpahnHadamiztkyLabel.setText(super.getSpahnHadamitzkyCodeString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(SpahnHadamiztkyLabel);

        javax.swing.GroupLayout SpahnHadamitzkyPanelLayout = new javax.swing.GroupLayout(SpahnHadamitzkyPanel);
        SpahnHadamitzkyPanel.setLayout(SpahnHadamitzkyPanelLayout);
        SpahnHadamitzkyPanelLayout.setHorizontalGroup(
            SpahnHadamitzkyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SpahnHadamiztkyLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        SpahnHadamitzkyPanelLayout.setVerticalGroup(
            SpahnHadamitzkyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SpahnHadamiztkyLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(SpahnHadamitzkyPanel);

        FourCornerTitlePanel.setBackground(java.awt.Color.red);

        FourCornerTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        FourCornerTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_QueryCodes_FourCorner));

        javax.swing.GroupLayout FourCornerTitlePanelLayout = new javax.swing.GroupLayout(FourCornerTitlePanel);
        FourCornerTitlePanel.setLayout(FourCornerTitlePanelLayout);
        FourCornerTitlePanelLayout.setHorizontalGroup(
            FourCornerTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(FourCornerTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        FourCornerTitlePanelLayout.setVerticalGroup(
            FourCornerTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(FourCornerTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(FourCornerTitlePanel);

        FourCornerLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        FourCornerLabel.setText(super.getFourCornerString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(FourCornerLabel);

        javax.swing.GroupLayout FourCornerPanelLayout = new javax.swing.GroupLayout(FourCornerPanel);
        FourCornerPanel.setLayout(FourCornerPanelLayout);
        FourCornerPanelLayout.setHorizontalGroup(
            FourCornerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(FourCornerLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        FourCornerPanelLayout.setVerticalGroup(
            FourCornerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(FourCornerLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(FourCornerPanel);

        DeRooTitlePanel.setBackground(java.awt.Color.cyan);

        DeRooTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        DeRooTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_QueryCodes_DeRoo));

        javax.swing.GroupLayout DeRooTitlePanelLayout = new javax.swing.GroupLayout(DeRooTitlePanel);
        DeRooTitlePanel.setLayout(DeRooTitlePanelLayout);
        DeRooTitlePanelLayout.setHorizontalGroup(
            DeRooTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DeRooTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        DeRooTitlePanelLayout.setVerticalGroup(
            DeRooTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DeRooTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(DeRooTitlePanel);

        DeRooLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        DeRooLabel.setText(super.getDeRooCodeString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(DeRooLabel);

        javax.swing.GroupLayout DeRooPanelLayout = new javax.swing.GroupLayout(DeRooPanel);
        DeRooPanel.setLayout(DeRooPanelLayout);
        DeRooPanelLayout.setHorizontalGroup(
            DeRooPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DeRooLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
        );
        DeRooPanelLayout.setVerticalGroup(
            DeRooPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DeRooLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
        );

        QueryPanel.add(DeRooPanel);

        javax.swing.GroupLayout VariantQueryPanelLayout = new javax.swing.GroupLayout(VariantQueryPanel);
        VariantQueryPanel.setLayout(VariantQueryPanelLayout);
        VariantQueryPanelLayout.setHorizontalGroup(
            VariantQueryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(VariantsTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(VariantsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(QueryTitlePanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(QueryPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        VariantQueryPanelLayout.setVerticalGroup(
            VariantQueryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(VariantQueryPanelLayout.createSequentialGroup()
                .addComponent(VariantsTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(VariantsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(QueryTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(QueryPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 128, Short.MAX_VALUE))
        );

        ExtraInfoPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        ExtraInfoPanel.setPreferredSize(new java.awt.Dimension(128, 128));

        JLPTLevelTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        JLPTLevelTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLPTLevelTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_JLPTLevel));

        javax.swing.GroupLayout JLPTLevelTitlePanelLayout = new javax.swing.GroupLayout(JLPTLevelTitlePanel);
        JLPTLevelTitlePanel.setLayout(JLPTLevelTitlePanelLayout);
        JLPTLevelTitlePanelLayout.setHorizontalGroup(
            JLPTLevelTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(JLPTLevelTitleLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        JLPTLevelTitlePanelLayout.setVerticalGroup(
            JLPTLevelTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(JLPTLevelTitleLabel)
        );

        FrequencyTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        FrequencyTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        FrequencyTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Frequency));

        javax.swing.GroupLayout FrequencyTitlePanelLayout = new javax.swing.GroupLayout(FrequencyTitlePanel);
        FrequencyTitlePanel.setLayout(FrequencyTitlePanelLayout);
        FrequencyTitlePanelLayout.setHorizontalGroup(
            FrequencyTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(FrequencyTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        FrequencyTitlePanelLayout.setVerticalGroup(
            FrequencyTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(FrequencyTitleLabel)
        );

        NelsonRadicalTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        NelsonRadicalTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        NelsonRadicalTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_NelsonRadical));

        javax.swing.GroupLayout NelsonRadicalTitlePanelLayout = new javax.swing.GroupLayout(NelsonRadicalTitlePanel);
        NelsonRadicalTitlePanel.setLayout(NelsonRadicalTitlePanelLayout);
        NelsonRadicalTitlePanelLayout.setHorizontalGroup(
            NelsonRadicalTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NelsonRadicalTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        NelsonRadicalTitlePanelLayout.setVerticalGroup(
            NelsonRadicalTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(NelsonRadicalTitleLabel)
        );

        JLPTLevelLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLPTLevelLabel.setText(super.getJLPTLevelString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(JLPTLevelLabel);

        FrequencyLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        FrequencyLabel.setText(super.getFrequencyString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(FrequencyLabel);

        NelsonRadicalLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        NelsonRadicalLabel.setText(super.getNelsonRadicalString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(NelsonRadicalLabel);

        UnicodeTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        UnicodeTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        UnicodeTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Unicode));

        javax.swing.GroupLayout UnicodeTitlePanelLayout = new javax.swing.GroupLayout(UnicodeTitlePanel);
        UnicodeTitlePanel.setLayout(UnicodeTitlePanelLayout);
        UnicodeTitlePanelLayout.setHorizontalGroup(
            UnicodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        UnicodeTitlePanelLayout.setVerticalGroup(
            UnicodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(UnicodeTitleLabel)
        );

        UnicodeLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        UnicodeLabel.setText(super.getUnicodeString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(UnicodeLabel);

        JisCodeTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        JisCodeTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JisCodeTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_JIS));

        javax.swing.GroupLayout JisCodeTitlePanelLayout = new javax.swing.GroupLayout(JisCodeTitlePanel);
        JisCodeTitlePanel.setLayout(JisCodeTitlePanelLayout);
        JisCodeTitlePanelLayout.setHorizontalGroup(
            JisCodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(JisCodeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        JisCodeTitlePanelLayout.setVerticalGroup(
            JisCodeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(JisCodeTitleLabel)
        );

        JisCharsetLabel.setForeground(java.awt.Color.red);
        JisCharsetLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JisCharsetLabel.setText(super.getJisCharset());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(JisCharsetLabel);

        JisCodelabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JisCodelabel.setText(super.getJisCodeString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(JisCodelabel);

        javax.swing.GroupLayout JisCodePanelLayout = new javax.swing.GroupLayout(JisCodePanel);
        JisCodePanel.setLayout(JisCodePanelLayout);
        JisCodePanelLayout.setHorizontalGroup(
            JisCodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(JisCodelabel, javax.swing.GroupLayout.PREFERRED_SIZE, 136, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(JisCharsetLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
        );
        JisCodePanelLayout.setVerticalGroup(
            JisCodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JisCodePanelLayout.createSequentialGroup()
                .addComponent(JisCharsetLabel)
                .addGap(2, 2, 2)
                .addComponent(JisCodelabel)
                .addGap(12, 12, 12))
        );

        javax.swing.GroupLayout ExtraInfoPanelLayout = new javax.swing.GroupLayout(ExtraInfoPanel);
        ExtraInfoPanel.setLayout(ExtraInfoPanelLayout);
        ExtraInfoPanelLayout.setHorizontalGroup(
            ExtraInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(JLPTLevelTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(JLPTLevelLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
            .addComponent(FrequencyTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(FrequencyLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
            .addComponent(NelsonRadicalTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(NelsonRadicalLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
            .addComponent(UnicodeTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(UnicodeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
            .addComponent(JisCodeTitlePanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(JisCodePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        ExtraInfoPanelLayout.setVerticalGroup(
            ExtraInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExtraInfoPanelLayout.createSequentialGroup()
                .addComponent(JLPTLevelTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(JLPTLevelLabel)
                .addGap(1, 1, 1)
                .addComponent(FrequencyTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(FrequencyLabel)
                .addGap(1, 1, 1)
                .addComponent(NelsonRadicalTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(NelsonRadicalLabel)
                .addGap(1, 1, 1)
                .addComponent(UnicodeTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(UnicodeLabel)
                .addGap(1, 1, 1)
                .addComponent(JisCodeTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(1, 1, 1)
                .addComponent(JisCodePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        DicReferencesPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));

        DicReferencesTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        DicReferencesTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        DicReferencesTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_DicReferences));

        javax.swing.GroupLayout DicReferencesTitlePanelLayout = new javax.swing.GroupLayout(DicReferencesTitlePanel);
        DicReferencesTitlePanel.setLayout(DicReferencesTitlePanelLayout);
        DicReferencesTitlePanelLayout.setHorizontalGroup(
            DicReferencesTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DicReferencesTitleLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 539, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        DicReferencesTitlePanelLayout.setVerticalGroup(
            DicReferencesTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DicReferencesTitlePanelLayout.createSequentialGroup()
                .addComponent(DicReferencesTitleLabel)
                .addGap(0, 0, 0))
        );

        DicReferencesList.setModel(super.getDicReferencesListModel());
        DicReferencesScrollPane.setViewportView(DicReferencesList);
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(DicReferencesList);

        javax.swing.GroupLayout DicReferencesPanelLayout = new javax.swing.GroupLayout(DicReferencesPanel);
        DicReferencesPanel.setLayout(DicReferencesPanelLayout);
        DicReferencesPanelLayout.setHorizontalGroup(
            DicReferencesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DicReferencesTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(DicReferencesScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 539, Short.MAX_VALUE)
        );
        DicReferencesPanelLayout.setVerticalGroup(
            DicReferencesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DicReferencesPanelLayout.createSequentialGroup()
                .addComponent(DicReferencesTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(DicReferencesScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );

        GraphPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));

        GraphTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        GraphTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        GraphTitleLabel.setText(kimwh.getMessage(Messages.WINKANJIINFO_PanelTitle_Graph));

        javax.swing.GroupLayout GraphTitlePanelLayout = new javax.swing.GroupLayout(GraphTitlePanel);
        GraphTitlePanel.setLayout(GraphTitlePanelLayout);
        GraphTitlePanelLayout.setHorizontalGroup(
            GraphTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GraphTitleLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 539, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        GraphTitlePanelLayout.setVerticalGroup(
            GraphTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(GraphTitlePanelLayout.createSequentialGroup()
                .addComponent(GraphTitleLabel)
                .addGap(0, 0, 0))
        );

        GraphLabel.setText(super.getGraphString());
        kimwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(GraphLabel);

        javax.swing.GroupLayout GraphPanelLayout = new javax.swing.GroupLayout(GraphPanel);
        GraphPanel.setLayout(GraphPanelLayout);
        GraphPanelLayout.setHorizontalGroup(
            GraphPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(GraphPanelLayout.createSequentialGroup()
                .addGroup(GraphPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(GraphTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(GraphPanelLayout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(GraphLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 527, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(0, 0, 0))
        );
        GraphPanelLayout.setVerticalGroup(
            GraphPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(GraphPanelLayout.createSequentialGroup()
                .addComponent(GraphTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(GraphLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout ExtendedKanjiInfoPanelLayout = new javax.swing.GroupLayout(ExtendedKanjiInfoPanel);
        ExtendedKanjiInfoPanel.setLayout(ExtendedKanjiInfoPanelLayout);
        ExtendedKanjiInfoPanelLayout.setHorizontalGroup(
            ExtendedKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExtendedKanjiInfoPanelLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addGroup(ExtendedKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ExtraInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE)
                    .addComponent(KanjiInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE)
                    .addComponent(KanjiLiteralPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE))
                .addGap(0, 0, 0)
                .addGroup(ExtendedKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(DicReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(ExtendedKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(ExtendedKanjiInfoPanelLayout.createSequentialGroup()
                            .addComponent(KanjiMeaningPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(0, 0, 0)
                            .addComponent(KanjiReadingsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 189, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(0, 0, 0)
                            .addComponent(VariantQueryPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addComponent(GraphPanel, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );
        ExtendedKanjiInfoPanelLayout.setVerticalGroup(
            ExtendedKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExtendedKanjiInfoPanelLayout.createSequentialGroup()
                .addGroup(ExtendedKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(VariantQueryPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(KanjiMeaningPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(KanjiReadingsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, ExtendedKanjiInfoPanelLayout.createSequentialGroup()
                        .addComponent(KanjiLiteralPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 127, Short.MAX_VALUE)
                        .addGap(0, 0, 0)
                        .addComponent(KanjiInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(0, 0, 0)
                .addGroup(ExtendedKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(ExtraInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 171, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, ExtendedKanjiInfoPanelLayout.createSequentialGroup()
                        .addComponent(DicReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(0, 0, 0)
                        .addComponent(GraphPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(0, 0, 0))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(ExtendedKanjiInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(ExtendedKanjiInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void StrokeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StrokeButtonActionPerformed
        kimwh.InvokeStrokeOrderFont(this);
    }//GEN-LAST:event_StrokeButtonActionPerformed

	private void RadicalMoreInfoButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_RadicalMoreInfoButtonActionPerformed
		kimwh.radicalInfoButtonPressed(kt.getClassicRadical(), this);
	}// GEN-LAST:event_RadicalMoreInfoButtonActionPerformed

	private void formWindowClosed(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_formWindowClosed
		kimwh.windowClosed(this);
	}// GEN-LAST:event_formWindowClosed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel DeRooLabel;
    private javax.swing.JPanel DeRooPanel;
    private javax.swing.JLabel DeRooTitleLabel;
    private javax.swing.JPanel DeRooTitlePanel;
    private javax.swing.JList DicReferencesList;
    private javax.swing.JPanel DicReferencesPanel;
    private javax.swing.JScrollPane DicReferencesScrollPane;
    private javax.swing.JLabel DicReferencesTitleLabel;
    private javax.swing.JPanel DicReferencesTitlePanel;
    private javax.swing.JPanel ExtendedKanjiInfoPanel;
    private javax.swing.JPanel ExtraInfoPanel;
    private javax.swing.JLabel FourCornerLabel;
    private javax.swing.JPanel FourCornerPanel;
    private javax.swing.JLabel FourCornerTitleLabel;
    private javax.swing.JPanel FourCornerTitlePanel;
    private javax.swing.JLabel FrequencyLabel;
    private javax.swing.JLabel FrequencyTitleLabel;
    private javax.swing.JPanel FrequencyTitlePanel;
    private javax.swing.JLabel GradeLabel;
    private javax.swing.JPanel GradePanel;
    private javax.swing.JLabel GradeTitleLabel;
    private javax.swing.JPanel GradeTitlePanel;
    private javax.swing.JLabel GraphLabel;
    private javax.swing.JPanel GraphPanel;
    private javax.swing.JLabel GraphTitleLabel;
    private javax.swing.JPanel GraphTitlePanel;
    private javax.swing.JLabel JLPTLevelLabel;
    private javax.swing.JLabel JLPTLevelTitleLabel;
    private javax.swing.JPanel JLPTLevelTitlePanel;
    private javax.swing.JLabel JisCharsetLabel;
    private javax.swing.JPanel JisCodePanel;
    private javax.swing.JLabel JisCodeTitleLabel;
    private javax.swing.JPanel JisCodeTitlePanel;
    private javax.swing.JLabel JisCodelabel;
    private javax.swing.JPanel KanjiInfoPanel;
    private javax.swing.JLabel KanjiLiteralLabel;
    private javax.swing.JPanel KanjiLiteralPanel;
    private javax.swing.JPanel KanjiMeaningPanel;
    private javax.swing.JPanel KanjiReadingsPanel;
    private javax.swing.JList MeaningsList;
    private javax.swing.JScrollPane MeaningsScrollPane;
    private javax.swing.JLabel MeaningsTitleLabel;
    private javax.swing.JPanel MeaningsTitlePanel;
    private javax.swing.JLabel NelsonRadicalLabel;
    private javax.swing.JLabel NelsonRadicalTitleLabel;
    private javax.swing.JPanel NelsonRadicalTitlePanel;
    private javax.swing.JPanel QueryPanel;
    private javax.swing.JLabel QueryTitleLabel;
    private javax.swing.JPanel QueryTitlePanel;
    private javax.swing.JLabel RadicalLabel;
    private javax.swing.JButton RadicalMoreInfoButton;
    private javax.swing.JPanel RadicalPanel;
    private javax.swing.JPanel RadicalTitle;
    private javax.swing.JLabel RadicalTitleLabel;
    private javax.swing.JPanel ReadingsPanel;
    private javax.swing.JLabel ReadingsTitleLabel;
    private javax.swing.JPanel ReadingsTitlePanel;
    private javax.swing.JLabel SkipCodeLabel;
    private javax.swing.JPanel SkipCodePanel;
    private javax.swing.JLabel SkipCodeTitleLabel;
    private javax.swing.JPanel SkipCodeTitlePanel;
    private javax.swing.JPanel SpahnHadamitzkyPanel;
    private javax.swing.JPanel SpahnHadamitzkyTitlePanel;
    private javax.swing.JLabel SpahnHadamiztkyLabel;
    private javax.swing.JLabel SpahnHadamiztkyTitleLabel;
    private javax.swing.JButton StrokeButton;
    private javax.swing.JLabel StrokeCountLabel;
    private javax.swing.JPanel StrokeCountPanel;
    private javax.swing.JLabel StrokeCountTitleLabel;
    private javax.swing.JPanel StrokeCountTitlePanel;
    private javax.swing.JLabel UnicodeLabel;
    private javax.swing.JLabel UnicodeTitleLabel;
    private javax.swing.JPanel UnicodeTitlePanel;
    private javax.swing.JPanel VariantQueryPanel;
    private javax.swing.JList VariantsList;
    private javax.swing.JPanel VariantsPanel;
    private javax.swing.JScrollPane VariantsScrollPane;
    private javax.swing.JLabel VariantsTitleLabel;
    private javax.swing.JPanel VariantsTitlePanel;
    // End of variables declaration//GEN-END:variables

}
