//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.jdk.gui.windows;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import net.ajaest.jdk.core.main.Launcher;
import net.ajaest.jdk.core.main.Messages;
import net.ajaest.jdk.core.winHandlers.MainWH;
import net.ajaest.lib.swing.panel.JDrawPanel;

//TODO: javadoc
public class MainWindow extends javax.swing.JFrame {

	private static final long serialVersionUID = -8931522474874478538L;

	private MainWH mwh;

    
    /** Creates new form MainWindow */
	public MainWindow(MainWH mwh) {
        super();
		// TODO: this action must be performed by win handler
        this.mwh = mwh;
		mwh.setWindow(this);
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        _resultControlPanel = new javax.swing.JPanel();
        _resultControl_DisposeAllWindowsButton = new javax.swing.JButton();
        _resultExportControlPanel = new javax.swing.JPanel();
        _resultExportControl_AllButton = new javax.swing.JButton();
        _resultExportControl_ResetButton = new javax.swing.JButton();
        _resultExportControl_InvertButton = new javax.swing.JButton();
        _controlsTabbedPane = new javax.swing.JTabbedPane();
        _drawTabPanel = new javax.swing.JPanel();
        _drawTab_DrawerPanel = new javax.swing.JPanel();
        _drawTab_ControlPanel = new javax.swing.JPanel();
        _drawTabControl_ResetButton = new javax.swing.JButton();
        _drawTabControl_RemoveLastStrokeButton = new javax.swing.JButton();
        _drawTabControl_RemoveLastLineButton = new javax.swing.JButton();
        _drawTab_QueryTableScrollPane = new javax.swing.JScrollPane();
        _drawTab_QueryTable = new javax.swing.JTable();
        _drawTab_QueryControlPanel = new javax.swing.JPanel();
        _drawTabQueryControl_ResetButton = new javax.swing.JButton();
        _drawTabQueryControl_RemoveButton = new javax.swing.JButton();
        _drawTab_AndOrPanel = new javax.swing.JPanel();
        _drawTabAndOr_AndAddButton = new javax.swing.JButton();
        _drawTabAndOr_OrButton = new javax.swing.JButton();
        _drawTab_ExecuteButton = new javax.swing.JButton();
        _criteriaTabPanel = new javax.swing.JPanel();
        _criteriaTab_QueryMakerPanel = new javax.swing.JPanel();
        _criteriaTabQueryMaker_FieldComboBox = new javax.swing.JComboBox();
        _criteriaTabQueryMaker_FulfilsLabel = new javax.swing.JLabel();
        _criteriaTabQueryMaker_FulfilsComboBox = new javax.swing.JComboBox();
        _criteriaTabQueryMaker_ValueComboBox = new javax.swing.JComboBox();
        _criteriaTabQueryMaker_AndAddButton = new javax.swing.JButton();
        _criteriaTabQueryMaker_OrButton = new javax.swing.JButton();
        ImageIcon topIcon = new ImageIcon(this.getClass().getResource("/images/help-browser_16.png"));
        _criteriaTabQueryMaker_InfoButton = new javax.swing.JButton(topIcon);
        _criteriaTab_QueryPanel = new javax.swing.JPanel();
        _criteriaTabQuery_QueryTableScrollPane = new javax.swing.JScrollPane();
        _criteriaTabQuery_QueryTable = new javax.swing.JTable();
        _criteriaTab_ControlPanel = new javax.swing.JPanel();
        _criteriaTabQueryControl_ModifyPanel = new javax.swing.JPanel();
        _criteriaQueryControlModify_ResetButton = new javax.swing.JButton();
        _criteriaQueryControlModify_RemoveButton = new javax.swing.JButton();
        _criteriaQueryControlModify_ModifyButton = new javax.swing.JButton();
        _criteriaTabQueryControl_ExecuteButton = new javax.swing.JButton();
        _exportTabPanel = new javax.swing.JPanel();
        _exportTab_AsPanel = new javax.swing.JPanel();
        _exportTabAs_FormatLabel = new javax.swing.JLabel();
        _exportTabAs_FormatComboBox = new javax.swing.JComboBox();
        _exportTabAs_StyleLabel = new javax.swing.JLabel();
        _exportTabAs_StyleComboBox = new javax.swing.JComboBox();
        _exportTabAs_PathTextField = new javax.swing.JTextField();
        _exportTabAs_PathButton = new javax.swing.JButton();
        _exportTabAs_Label = new javax.swing.JLabel();
        _exportTab_SortingPanel = new javax.swing.JPanel();
        _exportTabSorting_SortingJScrollPane = new javax.swing.JScrollPane();
        _exportTabSorting_SortingTable = new javax.swing.JTable();
        _exportTabSorting_ResetButton = new javax.swing.JButton();
        _exportTabSorting_RemoveButton = new javax.swing.JButton();
        _exportTabSorting_AddButton = new javax.swing.JButton();
        _exportTab_ExtraPanel = new javax.swing.JPanel();
        _exportTabExtra_RearrangeButton = new javax.swing.JButton();
        _exportTabExtra_MoreButton = new javax.swing.JButton();
        _exportTab_ExportButton = new javax.swing.JButton();
        _optionsTabPanel = new javax.swing.JPanel();
        _optionsTab_LanguajeLabel = new javax.swing.JLabel();
        _optionsTab_LanguajeComboBox = new javax.swing.JComboBox();
        _optionsTab_KanjiDictPathLabel = new javax.swing.JLabel();
        _optionsTab_ChangePathLabel = new javax.swing.JButton();
        _optionsTab_ExtendedInfoCheckBox = new javax.swing.JCheckBox();
        _optionsTab_ExtendedInfoLabel = new javax.swing.JLabel();
        _optionsTab_ExtendedIKanjiListLabel = new javax.swing.JLabel();
        _optionsTab_ExtendedIKanjiListCheckBox = new javax.swing.JCheckBox();
        _optionsTab_SaveButton = new javax.swing.JButton();
        _optionsTab_AboutButton = new javax.swing.JButton();
        _optionsTab_KanjiDictPathTextField = new javax.swing.JTextField();
        _optionsTab_KanaToRomajiLabel = new javax.swing.JLabel();
        _optionsTab_KanaToRomajiCheckBox = new javax.swing.JCheckBox();
        _optionsTab_ChangeStrokesPathLabel = new javax.swing.JButton();
        _optionsTab_StrokesPathLabel = new javax.swing.JLabel();
        _optionsTab_StrokesPathTextField = new javax.swing.JTextField();
        _resultsPanel = new javax.swing.JPanel();
        _results_KanjiGrid = new javax.swing.JPanel();

        _resultControlPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_RESULTS_BorderTextControls)));

        _resultControl_DisposeAllWindowsButton.setText(mwh.getMessage(Messages.WINMAIN_RESULTS_ButtonCloseAllWindows));
        _resultControl_DisposeAllWindowsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _resultControl_DisposeAllWindowsButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _resultControlPanelLayout = new javax.swing.GroupLayout(_resultControlPanel);
        _resultControlPanel.setLayout(_resultControlPanelLayout);
        _resultControlPanelLayout.setHorizontalGroup(
            _resultControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _resultControlPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_resultControl_DisposeAllWindowsButton, javax.swing.GroupLayout.DEFAULT_SIZE, 377, Short.MAX_VALUE)
                .addContainerGap())
        );
        _resultControlPanelLayout.setVerticalGroup(
            _resultControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(_resultControl_DisposeAllWindowsButton)
        );

        _resultExportControlPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_RESULTS_EXPORT_BorderTextControls)));

        _resultExportControl_AllButton.setText(mwh.getMessage(Messages.WINMAIN_RESULTS_ButtonExportAll));
        _resultExportControl_AllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _resultExportControl_AllButtonActionPerformed(evt);
            }
        });

        _resultExportControl_ResetButton.setText(mwh.getMessage(Messages.WINMAIN_RESULTS_ButtonExportReset));
        _resultExportControl_ResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _resultExportControl_ResetButtonActionPerformed(evt);
            }
        });

        _resultExportControl_InvertButton.setText(mwh.getMessage(Messages.WINMAIN_RESULTS_ButtonExportInvert));
        _resultExportControl_InvertButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _resultExportControl_InvertButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _resultExportControlPanelLayout = new javax.swing.GroupLayout(_resultExportControlPanel);
        _resultExportControlPanel.setLayout(_resultExportControlPanelLayout);
        _resultExportControlPanelLayout.setHorizontalGroup(
            _resultExportControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_resultExportControlPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_resultExportControl_AllButton, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(_resultExportControl_ResetButton, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(_resultExportControl_InvertButton, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18))
        );
        _resultExportControlPanelLayout.setVerticalGroup(
            _resultExportControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_resultExportControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(_resultExportControl_AllButton)
                .addComponent(_resultExportControl_ResetButton)
                .addComponent(_resultExportControl_InvertButton))
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(mwh.getMessage(Messages.WINMAIN_name));
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setIconImages(mwh.getIcons());
        setResizable(false);
        getContentPane().setLayout(new java.awt.GridLayout(1, 2));

        _controlsTabbedPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        _drawTabPanel.setPreferredSize(new java.awt.Dimension(0, 0));

        _drawTab_DrawerPanel.setBorder(new javax.swing.border.LineBorder(javax.swing.UIManager.getDefaults().getColor("dark"), 7, true));
        _drawTab_DrawerPanel.setPreferredSize(new java.awt.Dimension(155, 155));
        _drawTab_DrawerPanel.setLayout(new java.awt.BorderLayout());

        _drawTabDrawer_KanjiDrawPanel = new JDrawPanel();
        _drawTabDrawer_KanjiDrawPanel.setLayout(new java.awt.BorderLayout());
        JLabel backgroundImage = new JLabel(new ImageIcon(this.getClass().getResource("/images/drawGrid_150.png")));
        _drawTabDrawer_KanjiDrawPanel.add(backgroundImage);
        //_drawTabDrawer_KanjiDrawPanel.setOpaque(false);
        _drawTab_DrawerPanel.add(_drawTabDrawer_KanjiDrawPanel);

        _drawTab_ControlPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_STROKES_BorderTextControls)));

        _drawTabControl_ResetButton.setText(mwh.getMessage(Messages.WINMAIN_STROKES_ButtonDrawPanelReset));
        _drawTabControl_ResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTabControl_ResetButtonActionPerformed(evt);
            }
        });

        _drawTabControl_RemoveLastStrokeButton.setText(mwh.getMessage(Messages.WINMAIN_STROKES_ButtonDrawPanelRemoveLastStroke));
        _drawTabControl_RemoveLastStrokeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTabControl_RemoveLastStrokeButtonActionPerformed(evt);
            }
        });

        _drawTabControl_RemoveLastLineButton.setText(mwh.getMessage(Messages.WINMAIN_STROKES_ButtonDrawPanelRemoveLastLine));
        _drawTabControl_RemoveLastLineButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTabControl_RemoveLastLineButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _drawTab_ControlPanelLayout = new javax.swing.GroupLayout(_drawTab_ControlPanel);
        _drawTab_ControlPanel.setLayout(_drawTab_ControlPanelLayout);
        _drawTab_ControlPanelLayout.setHorizontalGroup(
            _drawTab_ControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTab_ControlPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_drawTab_ControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_drawTabControl_ResetButton, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE)
                    .addComponent(_drawTabControl_RemoveLastLineButton, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE)
                    .addComponent(_drawTabControl_RemoveLastStrokeButton, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE))
                .addContainerGap())
        );
        _drawTab_ControlPanelLayout.setVerticalGroup(
            _drawTab_ControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTab_ControlPanelLayout.createSequentialGroup()
                .addComponent(_drawTabControl_ResetButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(_drawTabControl_RemoveLastLineButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(_drawTabControl_RemoveLastStrokeButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        _drawTab_QueryTableScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryData)));
        _drawTab_QueryTableScrollPane.setPreferredSize(new java.awt.Dimension(0, 0));

        _drawTab_QueryTable.setFont(mwh.getUnicodeFont());
        _drawTab_QueryTable.setModel(mwh.getQueryTableModel());
        _drawTab_QueryTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_LAST_COLUMN);
        _drawTab_QueryTable.setDefaultRenderer(Object.class, mwh.getQueryTableCellRenderer());
        _drawTab_QueryTable.getColumnModel().getColumn(0).setMaxWidth(55);
        _drawTab_QueryTableScrollPane.setViewportView(_drawTab_QueryTable);

        _drawTab_QueryControlPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryControls)));

        _drawTabQueryControl_ResetButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlResetText));
        _drawTabQueryControl_ResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTabQueryControl_ResetButtonActionPerformed(evt);
            }
        });

        _drawTabQueryControl_RemoveButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlRemoveText));
        _drawTabQueryControl_RemoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTabQueryControl_RemoveButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _drawTab_QueryControlPanelLayout = new javax.swing.GroupLayout(_drawTab_QueryControlPanel);
        _drawTab_QueryControlPanel.setLayout(_drawTab_QueryControlPanelLayout);
        _drawTab_QueryControlPanelLayout.setHorizontalGroup(
            _drawTab_QueryControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTab_QueryControlPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_drawTabQueryControl_ResetButton, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(_drawTabQueryControl_RemoveButton, javax.swing.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE)
                .addContainerGap())
        );
        _drawTab_QueryControlPanelLayout.setVerticalGroup(
            _drawTab_QueryControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTab_QueryControlPanelLayout.createSequentialGroup()
                .addGroup(_drawTab_QueryControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_drawTabQueryControl_ResetButton)
                    .addComponent(_drawTabQueryControl_RemoveButton))
                .addContainerGap(6, Short.MAX_VALUE))
        );

        _drawTab_AndOrPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_STROKES_BorderTextAndOr)));

        _drawTabAndOr_AndAddButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryMakerAddText));
        _drawTabAndOr_AndAddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTabAndOr_AndAddButtonActionPerformed(evt);
            }
        });

        _drawTabAndOr_OrButton.setText(mwh.getMessage(Messages.WINMAIN_QUERY_DATA_cellOrString));
        _drawTabAndOr_OrButton.setEnabled(false);
        _drawTabAndOr_OrButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTabAndOr_OrButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _drawTab_AndOrPanelLayout = new javax.swing.GroupLayout(_drawTab_AndOrPanel);
        _drawTab_AndOrPanel.setLayout(_drawTab_AndOrPanelLayout);
        _drawTab_AndOrPanelLayout.setHorizontalGroup(
            _drawTab_AndOrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTab_AndOrPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_drawTabAndOr_AndAddButton, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_drawTabAndOr_OrButton, javax.swing.GroupLayout.PREFERRED_SIZE, 53, Short.MAX_VALUE)
                .addContainerGap())
        );
        _drawTab_AndOrPanelLayout.setVerticalGroup(
            _drawTab_AndOrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTab_AndOrPanelLayout.createSequentialGroup()
                .addGroup(_drawTab_AndOrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_drawTabAndOr_AndAddButton)
                    .addComponent(_drawTabAndOr_OrButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        _drawTab_ExecuteButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlExecuteText));
        _drawTab_ExecuteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _drawTab_ExecuteButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _drawTabPanelLayout = new javax.swing.GroupLayout(_drawTabPanel);
        _drawTabPanel.setLayout(_drawTabPanelLayout);
        _drawTabPanelLayout.setHorizontalGroup(
            _drawTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_drawTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_drawTab_QueryTableScrollPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 368, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _drawTabPanelLayout.createSequentialGroup()
                        .addGroup(_drawTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(_drawTab_AndOrPanel, 0, 155, Short.MAX_VALUE)
                            .addComponent(_drawTab_DrawerPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(_drawTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(_drawTab_ExecuteButton, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                            .addComponent(_drawTab_ControlPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(_drawTab_QueryControlPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        _drawTabPanelLayout.setVerticalGroup(
            _drawTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_drawTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_drawTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(_drawTabPanelLayout.createSequentialGroup()
                        .addComponent(_drawTab_DrawerPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_drawTab_AndOrPanel, 0, 55, Short.MAX_VALUE))
                    .addGroup(_drawTabPanelLayout.createSequentialGroup()
                        .addComponent(_drawTab_ControlPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_drawTab_ExecuteButton, javax.swing.GroupLayout.DEFAULT_SIZE, 66, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_drawTab_QueryTableScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_drawTab_QueryControlPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(6, 6, 6))
        );

        _controlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Drawing), _drawTabPanel);

        _criteriaTabPanel.setPreferredSize(new java.awt.Dimension(0, 0));

        _criteriaTab_QueryMakerPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryMaker)));
        _criteriaTab_QueryMakerPanel.setName("asd"); // NOI18N

        _criteriaTabQueryMaker_FieldComboBox.setModel(mwh.getCriteriaFieldComboBoxModel());
        _criteriaTabQueryMaker_FieldComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaTabQueryMaker_FieldComboBox_ActionPerformed(evt);
            }
        });

        _criteriaTabQueryMaker_FulfilsLabel.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_LabelFulfilsComboBox));

        _criteriaTabQueryMaker_FulfilsComboBox.setEnabled(false);

        _criteriaTabQueryMaker_ValueComboBox.setEditable(true);
        _criteriaTabQueryMaker_ValueComboBox.setFont(mwh.getUnicodeFont());
        _criteriaTabQueryMaker_ValueComboBox.setEnabled(false);
        mwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(_criteriaTabQueryMaker_ValueComboBox);

        _criteriaTabQueryMaker_AndAddButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryMakerAddText));
        _criteriaTabQueryMaker_AndAddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaTabQueryMaker_AndAddButtonActionPerformed(evt);
            }
        });

        _criteriaTabQueryMaker_OrButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryMakerOrText));
        _criteriaTabQueryMaker_OrButton.setEnabled(false);
        _criteriaTabQueryMaker_OrButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaTabQueryMaker_OrButtonActionPerformed(evt);
            }
        });

        _criteriaTabQueryMaker_InfoButton.setEnabled(false);
        _criteriaTabQueryMaker_InfoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaTabQueryMaker_InfoButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _criteriaTab_QueryMakerPanelLayout = new javax.swing.GroupLayout(_criteriaTab_QueryMakerPanel);
        _criteriaTab_QueryMakerPanel.setLayout(_criteriaTab_QueryMakerPanelLayout);
        _criteriaTab_QueryMakerPanelLayout.setHorizontalGroup(
            _criteriaTab_QueryMakerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_criteriaTab_QueryMakerPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_criteriaTab_QueryMakerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_criteriaTabQueryMaker_ValueComboBox, 0, 238, Short.MAX_VALUE)
                    .addGroup(_criteriaTab_QueryMakerPanelLayout.createSequentialGroup()
                        .addComponent(_criteriaTabQueryMaker_FulfilsLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_criteriaTabQueryMaker_FulfilsComboBox, 0, 140, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _criteriaTab_QueryMakerPanelLayout.createSequentialGroup()
                        .addComponent(_criteriaTabQueryMaker_FieldComboBox, 0, 207, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_criteriaTabQueryMaker_InfoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(_criteriaTab_QueryMakerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(_criteriaTabQueryMaker_OrButton, 0, 0, Short.MAX_VALUE)
                    .addComponent(_criteriaTabQueryMaker_AndAddButton, javax.swing.GroupLayout.PREFERRED_SIZE, 84, Short.MAX_VALUE))
                .addContainerGap())
        );
        _criteriaTab_QueryMakerPanelLayout.setVerticalGroup(
            _criteriaTab_QueryMakerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_criteriaTab_QueryMakerPanelLayout.createSequentialGroup()
                .addGroup(_criteriaTab_QueryMakerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(_criteriaTab_QueryMakerPanelLayout.createSequentialGroup()
                        .addGroup(_criteriaTab_QueryMakerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(_criteriaTabQueryMaker_FieldComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(_criteriaTabQueryMaker_InfoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(_criteriaTab_QueryMakerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(_criteriaTabQueryMaker_FulfilsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(_criteriaTabQueryMaker_FulfilsLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_criteriaTabQueryMaker_ValueComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(_criteriaTab_QueryMakerPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(_criteriaTabQueryMaker_AndAddButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(_criteriaTabQueryMaker_OrButton)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        _criteriaTab_QueryPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryData)));
        _criteriaTab_QueryPanel.setMinimumSize(new java.awt.Dimension(34, 1000));
        _criteriaTab_QueryPanel.setPreferredSize(new java.awt.Dimension(0, 0));
        _criteriaTab_QueryPanel.setLayout(new java.awt.BorderLayout());

        _criteriaTabQuery_QueryTableScrollPane.setPreferredSize(new java.awt.Dimension(0, 0));

        _criteriaTabQuery_QueryTable.setFont(mwh.getUnicodeFont());
        _criteriaTabQuery_QueryTable.setModel(mwh.getQueryTableModel());
        _criteriaTabQuery_QueryTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_LAST_COLUMN);
        _criteriaTabQuery_QueryTable.setDefaultRenderer(Object.class, mwh.getQueryTableCellRenderer());
        _criteriaTabQuery_QueryTable.getColumnModel().getColumn(0).setMaxWidth(55);
        _criteriaTabQuery_QueryTableScrollPane.setViewportView(_criteriaTabQuery_QueryTable);

        _criteriaTab_QueryPanel.add(_criteriaTabQuery_QueryTableScrollPane, java.awt.BorderLayout.CENTER);

        _criteriaTabQueryControl_ModifyPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryControls)));

        _criteriaQueryControlModify_ResetButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlResetText));
        _criteriaQueryControlModify_ResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaQueryControlModify_ResetButtonActionPerformed(evt);
            }
        });

        _criteriaQueryControlModify_RemoveButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlRemoveText));
        _criteriaQueryControlModify_RemoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaQueryControlModify_RemoveButtonActionPerformed(evt);
            }
        });

        _criteriaQueryControlModify_ModifyButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlModifyText));
        _criteriaQueryControlModify_ModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaQueryControlModify_ModifyButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _criteriaTabQueryControl_ModifyPanelLayout = new javax.swing.GroupLayout(_criteriaTabQueryControl_ModifyPanel);
        _criteriaTabQueryControl_ModifyPanel.setLayout(_criteriaTabQueryControl_ModifyPanelLayout);
        _criteriaTabQueryControl_ModifyPanelLayout.setHorizontalGroup(
            _criteriaTabQueryControl_ModifyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_criteriaTabQueryControl_ModifyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_criteriaQueryControlModify_ResetButton, javax.swing.GroupLayout.DEFAULT_SIZE, 101, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_criteriaQueryControlModify_RemoveButton, javax.swing.GroupLayout.DEFAULT_SIZE, 108, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_criteriaQueryControlModify_ModifyButton, javax.swing.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)
                .addContainerGap())
        );
        _criteriaTabQueryControl_ModifyPanelLayout.setVerticalGroup(
            _criteriaTabQueryControl_ModifyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_criteriaTabQueryControl_ModifyPanelLayout.createSequentialGroup()
                .addGroup(_criteriaTabQueryControl_ModifyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_criteriaQueryControlModify_ResetButton)
                    .addComponent(_criteriaQueryControlModify_RemoveButton)
                    .addComponent(_criteriaQueryControlModify_ModifyButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        _criteriaTabQueryControl_ExecuteButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlExecuteText));
        _criteriaTabQueryControl_ExecuteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _criteriaTabQueryControl_ExecuteButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _criteriaTab_ControlPanelLayout = new javax.swing.GroupLayout(_criteriaTab_ControlPanel);
        _criteriaTab_ControlPanel.setLayout(_criteriaTab_ControlPanelLayout);
        _criteriaTab_ControlPanelLayout.setHorizontalGroup(
            _criteriaTab_ControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _criteriaTab_ControlPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_criteriaTab_ControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(_criteriaTabQueryControl_ExecuteButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 364, Short.MAX_VALUE)
                    .addComponent(_criteriaTabQueryControl_ModifyPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        _criteriaTab_ControlPanelLayout.setVerticalGroup(
            _criteriaTab_ControlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_criteriaTab_ControlPanelLayout.createSequentialGroup()
                .addComponent(_criteriaTabQueryControl_ModifyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_criteriaTabQueryControl_ExecuteButton, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout _criteriaTabPanelLayout = new javax.swing.GroupLayout(_criteriaTabPanel);
        _criteriaTabPanel.setLayout(_criteriaTabPanelLayout);
        _criteriaTabPanelLayout.setHorizontalGroup(
            _criteriaTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(_criteriaTab_ControlPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _criteriaTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_criteriaTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(_criteriaTab_QueryPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 364, Short.MAX_VALUE)
                    .addComponent(_criteriaTab_QueryMakerPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        _criteriaTabPanelLayout.setVerticalGroup(
            _criteriaTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_criteriaTabPanelLayout.createSequentialGroup()
                .addComponent(_criteriaTab_QueryMakerPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_criteriaTab_QueryPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 145, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_criteriaTab_ControlPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        _controlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Criteria), _criteriaTabPanel);

        _exportTabPanel.setPreferredSize(new java.awt.Dimension(400, 400));

        _exportTab_AsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_EXPORT_BorderTextExportAs)));

        _exportTabAs_FormatLabel.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_LabelFormatComboBox));

        _exportTabAs_FormatComboBox.setModel(mwh.getExportFormatModel());
        _exportTabAs_FormatComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabAs_FormatComboBoxActionPerformed(evt);
            }
        });

        _exportTabAs_StyleLabel.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_LabelStyleComboBox));

        _exportTabAs_StyleComboBox.setModel(mwh.getExportStyleModel());
        _exportTabAs_StyleComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabAs_StyleComboBoxActionPerformed(evt);
            }
        });

        mwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(_exportTabAs_PathTextField);
        //_exportTabAs_PathTextField.add(new JTextComponentContextMenu(_exportTabAs_PathTextField));

        _exportTabAs_PathButton.setText("...");
        _exportTabAs_PathButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabAs_PathButtonActionPerformed(evt);
            }
        });

        _exportTabAs_Label.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_LabelDirButton));

        javax.swing.GroupLayout _exportTab_AsPanelLayout = new javax.swing.GroupLayout(_exportTab_AsPanel);
        _exportTab_AsPanel.setLayout(_exportTab_AsPanelLayout);
        _exportTab_AsPanelLayout.setHorizontalGroup(
            _exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_exportTab_AsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(_exportTabAs_Label, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(_exportTabAs_StyleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(_exportTabAs_FormatLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGroup(_exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(_exportTab_AsPanelLayout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(_exportTabAs_FormatComboBox, 0, 228, Short.MAX_VALUE))
                    .addGroup(_exportTab_AsPanelLayout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(_exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(_exportTabAs_StyleComboBox, 0, 228, Short.MAX_VALUE)
                            .addGroup(_exportTab_AsPanelLayout.createSequentialGroup()
                                .addComponent(_exportTabAs_PathButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(_exportTabAs_PathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 198, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        _exportTab_AsPanelLayout.setVerticalGroup(
            _exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_exportTab_AsPanelLayout.createSequentialGroup()
                .addGroup(_exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_exportTabAs_FormatLabel)
                    .addComponent(_exportTabAs_FormatComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(_exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_exportTabAs_StyleLabel)
                    .addComponent(_exportTabAs_StyleComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addGroup(_exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_exportTabAs_Label, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE)
                    .addGroup(_exportTab_AsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(_exportTabAs_PathButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(_exportTabAs_PathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        _exportTab_SortingPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_EXPORT_BorderTextExportSorting)));

        _exportTabSorting_SortingTable.setModel(mwh.getExportSorterTableModel());
        _exportTabSorting_SortingTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_LAST_COLUMN);
        _exportTabSorting_SortingTable.getColumnModel().getColumn(0).setMaxWidth(50);
        _exportTabSorting_SortingJScrollPane.setViewportView(_exportTabSorting_SortingTable);

        _exportTabSorting_ResetButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonSortingReset));
        _exportTabSorting_ResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabSorting_ResetButtonActionPerformed(evt);
            }
        });

        _exportTabSorting_RemoveButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonSortingRemove));
        _exportTabSorting_RemoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabSorting_RemoveButtonActionPerformed(evt);
            }
        });

        _exportTabSorting_AddButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonSortingAdd));
        _exportTabSorting_AddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabSorting_AddButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _exportTab_SortingPanelLayout = new javax.swing.GroupLayout(_exportTab_SortingPanel);
        _exportTab_SortingPanel.setLayout(_exportTab_SortingPanelLayout);
        _exportTab_SortingPanelLayout.setHorizontalGroup(
            _exportTab_SortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _exportTab_SortingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_exportTabSorting_AddButton, javax.swing.GroupLayout.DEFAULT_SIZE, 102, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_exportTabSorting_ResetButton, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_exportTabSorting_RemoveButton, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .addGroup(_exportTab_SortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(_exportTab_SortingPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(_exportTabSorting_SortingJScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 332, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );
        _exportTab_SortingPanelLayout.setVerticalGroup(
            _exportTab_SortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_exportTab_SortingPanelLayout.createSequentialGroup()
                .addContainerGap(95, Short.MAX_VALUE)
                .addGroup(_exportTab_SortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_exportTabSorting_RemoveButton)
                    .addComponent(_exportTabSorting_ResetButton)
                    .addComponent(_exportTabSorting_AddButton)))
            .addGroup(_exportTab_SortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(_exportTab_SortingPanelLayout.createSequentialGroup()
                    .addComponent(_exportTabSorting_SortingJScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(37, Short.MAX_VALUE)))
        );

        _exportTab_ExtraPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_EXPORT_BorderTextExportExtra)));

        _exportTabExtra_RearrangeButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonExtraRearrange));
        _exportTabExtra_RearrangeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabExtra_RearrangeButtonActionPerformed(evt);
            }
        });

        _exportTabExtra_MoreButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonExtraOptions));
        _exportTabExtra_MoreButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTabExtra_MoreButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _exportTab_ExtraPanelLayout = new javax.swing.GroupLayout(_exportTab_ExtraPanel);
        _exportTab_ExtraPanel.setLayout(_exportTab_ExtraPanelLayout);
        _exportTab_ExtraPanelLayout.setHorizontalGroup(
            _exportTab_ExtraPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_exportTab_ExtraPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_exportTab_ExtraPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_exportTabExtra_RearrangeButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 106, Short.MAX_VALUE)
                    .addComponent(_exportTabExtra_MoreButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 106, Short.MAX_VALUE))
                .addContainerGap())
        );
        _exportTab_ExtraPanelLayout.setVerticalGroup(
            _exportTab_ExtraPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _exportTab_ExtraPanelLayout.createSequentialGroup()
                .addComponent(_exportTabExtra_RearrangeButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(8, 8, 8)
                .addComponent(_exportTabExtra_MoreButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        _exportTab_ExportButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonExport));
        _exportTab_ExportButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _exportTab_ExportButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout _exportTabPanelLayout = new javax.swing.GroupLayout(_exportTabPanel);
        _exportTabPanel.setLayout(_exportTabPanelLayout);
        _exportTabPanelLayout.setHorizontalGroup(
            _exportTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_exportTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_exportTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_exportTab_SortingPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _exportTabPanelLayout.createSequentialGroup()
                        .addComponent(_exportTab_ExtraPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(18, 18, 18)
                        .addComponent(_exportTab_ExportButton, javax.swing.GroupLayout.PREFERRED_SIZE, 208, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(_exportTab_AsPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        _exportTabPanelLayout.setVerticalGroup(
            _exportTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_exportTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_exportTab_AsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_exportTab_SortingPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(_exportTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_exportTab_ExtraPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(_exportTab_ExportButton, javax.swing.GroupLayout.DEFAULT_SIZE, 101, Short.MAX_VALUE))
                .addContainerGap())
        );

        _controlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Export), _exportTabPanel);

        _optionsTab_LanguajeLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelLanguajeComboBox));

        _optionsTab_LanguajeComboBox.setModel(mwh.getOptionLanguageComboBoxModel());

        _optionsTab_KanjiDictPathLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelKanjiFileTextField));

        _optionsTab_ChangePathLabel.setText("...");
        _optionsTab_ChangePathLabel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _optionsTab_ChangePathLabelActionPerformed(evt);
            }
        });

        _optionsTab_ExtendedInfoLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelExtendedInfoCheckBox));

        _optionsTab_ExtendedIKanjiListLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelExtendedKanjiListCheckBox));

        _optionsTab_SaveButton.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_ButtonSave));
        _optionsTab_SaveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _optionsTab_SaveButtonActionPerformed(evt);
            }
        });

        _optionsTab_AboutButton.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_ButtonAbout));
        _optionsTab_AboutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _optionsTab_AboutButtonActionPerformed(evt);
            }
        });

        mwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(_optionsTab_KanjiDictPathTextField );

        _optionsTab_KanaToRomajiLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelRomajiCheckBox));

        _optionsTab_ChangeStrokesPathLabel.setText("...");
        _optionsTab_ChangeStrokesPathLabel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _optionsTab_ChangeStrokesPathLabelActionPerformed(evt);
            }
        });

        _optionsTab_StrokesPathLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelStrokeFileTextField));

        mwh.getJDKGuiEngine().getEditContextMenuEngine().addContextMenu(_optionsTab_StrokesPathTextField);

        javax.swing.GroupLayout _optionsTabPanelLayout = new javax.swing.GroupLayout(_optionsTabPanel);
        _optionsTabPanel.setLayout(_optionsTabPanelLayout);
        _optionsTabPanelLayout.setHorizontalGroup(
            _optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                        .addComponent(_optionsTab_LanguajeLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_optionsTab_LanguajeComboBox, 0, 271, Short.MAX_VALUE))
                    .addComponent(_optionsTab_KanjiDictPathLabel)
                    .addComponent(_optionsTab_StrokesPathLabel)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _optionsTabPanelLayout.createSequentialGroup()
                        .addComponent(_optionsTab_ChangePathLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_optionsTab_KanjiDictPathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE))
                    .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                        .addComponent(_optionsTab_ChangeStrokesPathLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_optionsTab_StrokesPathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE))
                    .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                        .addComponent(_optionsTab_SaveButton, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(_optionsTab_AboutButton, javax.swing.GroupLayout.DEFAULT_SIZE, 170, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, _optionsTabPanelLayout.createSequentialGroup()
                        .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(_optionsTab_ExtendedInfoLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 331, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(_optionsTab_ExtendedIKanjiListLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 331, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(_optionsTab_KanaToRomajiLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 331, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(_optionsTab_ExtendedIKanjiListCheckBox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(_optionsTab_ExtendedInfoCheckBox))
                            .addComponent(_optionsTab_KanaToRomajiCheckBox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );
        _optionsTabPanelLayout.setVerticalGroup(
            _optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_optionsTab_LanguajeLabel)
                    .addComponent(_optionsTab_LanguajeComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(_optionsTab_KanjiDictPathLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(_optionsTab_ChangePathLabel, 0, 0, Short.MAX_VALUE)
                    .addComponent(_optionsTab_KanjiDictPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addComponent(_optionsTab_StrokesPathLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(_optionsTab_ChangeStrokesPathLabel, 0, 0, Short.MAX_VALUE)
                    .addComponent(_optionsTab_StrokesPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_optionsTab_ExtendedInfoCheckBox)
                    .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                        .addComponent(_optionsTab_ExtendedInfoLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(7, 7, 7)))
                .addGap(12, 12, 12)
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_optionsTab_ExtendedIKanjiListCheckBox)
                    .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                        .addComponent(_optionsTab_ExtendedIKanjiListLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(7, 7, 7)))
                .addGap(18, 18, 18)
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_optionsTab_KanaToRomajiCheckBox)
                    .addGroup(_optionsTabPanelLayout.createSequentialGroup()
                        .addComponent(_optionsTab_KanaToRomajiLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(7, 7, 7)))
                .addGap(11, 11, 11)
                .addGroup(_optionsTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(_optionsTab_SaveButton)
                    .addComponent(_optionsTab_AboutButton))
                .addGap(72, 72, 72))
        );

        _controlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Config), _optionsTabPanel);

        ChangeListener tabChanged = new ChangeListener() {
            public void stateChanged(ChangeEvent changeEvent) {
                JTabbedPane sourceTabbedPane = (JTabbedPane) changeEvent.getSource();
                int index = sourceTabbedPane.getSelectedIndex();
                mwh.tabChangedActionPerformed(index);
            }
        };
        _controlsTabbedPane.addChangeListener(tabChanged);

        getContentPane().add(_controlsTabbedPane);

        _resultsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_RESULTS_BorderTextResults)));
        _resultsPanel.setLayout(new java.awt.BorderLayout());

        _results_KanjiGrid.setFont(mwh.getUnicodeFont());

        javax.swing.GroupLayout _results_KanjiGridLayout = new javax.swing.GroupLayout(_results_KanjiGrid);
        _results_KanjiGrid.setLayout(_results_KanjiGridLayout);
        _results_KanjiGridLayout.setHorizontalGroup(
            _results_KanjiGridLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 384, Short.MAX_VALUE)
        );
        _results_KanjiGridLayout.setVerticalGroup(
            _results_KanjiGridLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 425, Short.MAX_VALUE)
        );

        _resultsPanel.add(_results_KanjiGrid, java.awt.BorderLayout.CENTER);

        getContentPane().add(_resultsPanel);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-800)/2, (screenSize.height-480)/2, 800, 480);
    }// </editor-fold>//GEN-END:initComponents

    private void _drawTab_ExecuteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTab_ExecuteButtonActionPerformed
        mwh.executeDrawQuery();
    }//GEN-LAST:event__drawTab_ExecuteButtonActionPerformed

    private void _exportTabAs_PathButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTabAs_PathButtonActionPerformed
        mwh.changeExportPath();
    }//GEN-LAST:event__exportTabAs_PathButtonActionPerformed

    private void _optionsTab_ChangePathLabelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__optionsTab_ChangePathLabelActionPerformed
        mwh.kanjiFileChoose();
    }//GEN-LAST:event__optionsTab_ChangePathLabelActionPerformed

    private void _optionsTab_SaveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__optionsTab_SaveButtonActionPerformed
        mwh.saveConfig();
    }//GEN-LAST:event__optionsTab_SaveButtonActionPerformed

    private void _optionsTab_ChangeStrokesPathLabelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__optionsTab_ChangeStrokesPathLabelActionPerformed
        mwh.strokeFileChoose();
    }//GEN-LAST:event__optionsTab_ChangeStrokesPathLabelActionPerformed

    private void _criteriaTabQueryMaker_FieldComboBox_ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaTabQueryMaker_FieldComboBox_ActionPerformed
		mwh.updateChoosableQueryComboBoxes();
    }//GEN-LAST:event__criteriaTabQueryMaker_FieldComboBox_ActionPerformed

    private void _criteriaTabQueryMaker_AndAddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaTabQueryMaker_AndAddButtonActionPerformed
		mwh.addAndQueryButtonPressed();
    }//GEN-LAST:event__criteriaTabQueryMaker_AndAddButtonActionPerformed

    private void _criteriaTabQueryMaker_OrButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaTabQueryMaker_OrButtonActionPerformed
        mwh.orQueryButtonPressed();
    }//GEN-LAST:event__criteriaTabQueryMaker_OrButtonActionPerformed

    private void _criteriaQueryControlModify_ResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaQueryControlModify_ResetButtonActionPerformed
        mwh.QueryModifierResetButtonPressed();
    }//GEN-LAST:event__criteriaQueryControlModify_ResetButtonActionPerformed

    private void _criteriaQueryControlModify_RemoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaQueryControlModify_RemoveButtonActionPerformed
        mwh.QueryModifierRemoveButtonPressed();
    }//GEN-LAST:event__criteriaQueryControlModify_RemoveButtonActionPerformed

    private void _criteriaQueryControlModify_ModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaQueryControlModify_ModifyButtonActionPerformed
        mwh.QueryModifierModifyButtonPressed();
    }//GEN-LAST:event__criteriaQueryControlModify_ModifyButtonActionPerformed

    private void _drawTabControl_ResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTabControl_ResetButtonActionPerformed
        mwh.drawResetButtonPressed();
    }//GEN-LAST:event__drawTabControl_ResetButtonActionPerformed

    private void _drawTabControl_RemoveLastLineButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTabControl_RemoveLastLineButtonActionPerformed
        mwh.drawRemoveLastLineButtonPressed();
    }//GEN-LAST:event__drawTabControl_RemoveLastLineButtonActionPerformed

    private void _drawTabControl_RemoveLastStrokeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTabControl_RemoveLastStrokeButtonActionPerformed
        mwh.drawRemoveLastStrokeButtonPressed();
    }//GEN-LAST:event__drawTabControl_RemoveLastStrokeButtonActionPerformed

    private void _drawTabAndOr_AndAddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTabAndOr_AndAddButtonActionPerformed
        mwh.drawAndButtonPressed();
    }//GEN-LAST:event__drawTabAndOr_AndAddButtonActionPerformed

    private void _drawTabQueryControl_ResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTabQueryControl_ResetButtonActionPerformed
        mwh.QueryModifierResetButtonPressed();
    }//GEN-LAST:event__drawTabQueryControl_ResetButtonActionPerformed

    private void _drawTabQueryControl_RemoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTabQueryControl_RemoveButtonActionPerformed
        mwh.QueryModifierRemoveButtonPressed();
    }//GEN-LAST:event__drawTabQueryControl_RemoveButtonActionPerformed

    private void _drawTabAndOr_OrButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__drawTabAndOr_OrButtonActionPerformed
        mwh.drawOrButtonPressed();
    }//GEN-LAST:event__drawTabAndOr_OrButtonActionPerformed

    private void _exportTabAs_FormatComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTabAs_FormatComboBoxActionPerformed
        mwh._exportTabAs_formatComboBoxSelectionModified();
    }//GEN-LAST:event__exportTabAs_FormatComboBoxActionPerformed

    private void _exportTabExtra_MoreButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTabExtra_MoreButtonActionPerformed
        mwh.exportMoreButtonPressed();
    }//GEN-LAST:event__exportTabExtra_MoreButtonActionPerformed

    private void _resultControl_DisposeAllWindowsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__resultControl_DisposeAllWindowsButtonActionPerformed
        mwh.exportResultDisposeAllWindowsButtonPressed();
    }//GEN-LAST:event__resultControl_DisposeAllWindowsButtonActionPerformed

    private void _exportTabExtra_RearrangeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTabExtra_RearrangeButtonActionPerformed
        mwh.exportRearrangeButtonPressed();
    }//GEN-LAST:event__exportTabExtra_RearrangeButtonActionPerformed

    private void _exportTabSorting_AddButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                            
        mwh.exportSorterAddButtonPressed();
	}// GEN-LAST:event__exportTabSorting_AddButtonActionPerformed

    private void _exportTabSorting_ResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTabSorting_ResetButtonActionPerformed
        mwh.exportSorterResetButtonPressed();
    }//GEN-LAST:event__exportTabSorting_ResetButtonActionPerformed

    private void _exportTabSorting_RemoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTabSorting_RemoveButtonActionPerformed
        mwh.exportSorterRemoveButtonPressed();
    }//GEN-LAST:event__exportTabSorting_RemoveButtonActionPerformed

    private void _exportTab_ExportButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTab_ExportButtonActionPerformed
        mwh.exportExportButtonPressed();
    }//GEN-LAST:event__exportTab_ExportButtonActionPerformed

    private void _optionsTab_AboutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__optionsTab_AboutButtonActionPerformed
        mwh.optionsAboutButtonPressed();
    }//GEN-LAST:event__optionsTab_AboutButtonActionPerformed

    private void _resultExportControl_AllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__resultExportControl_AllButtonActionPerformed
        mwh.exportResultPanelSelectAllButtonPressed();
    }//GEN-LAST:event__resultExportControl_AllButtonActionPerformed

    private void _resultExportControl_ResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__resultExportControl_ResetButtonActionPerformed
        mwh.exportResultPanelResetButtonPressed();
    }//GEN-LAST:event__resultExportControl_ResetButtonActionPerformed

    private void _resultExportControl_InvertButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__resultExportControl_InvertButtonActionPerformed
        mwh.exportResultPanelInvertButtonPressed();
    }//GEN-LAST:event__resultExportControl_InvertButtonActionPerformed

    private void _criteriaTabQueryControl_ExecuteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaTabQueryControl_ExecuteButtonActionPerformed
        mwh.executeQuery();
    }//GEN-LAST:event__criteriaTabQueryControl_ExecuteButtonActionPerformed

    private void _criteriaTabQueryMaker_InfoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__criteriaTabQueryMaker_InfoButtonActionPerformed
        mwh._criteriaTabQueryMaker_InfoButtonPressed();
    }//GEN-LAST:event__criteriaTabQueryMaker_InfoButtonActionPerformed

    private void _exportTabAs_StyleComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__exportTabAs_StyleComboBoxActionPerformed
        mwh._exportTabAs_styleComboBoxSelectionModified();
    }//GEN-LAST:event__exportTabAs_StyleComboBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane _controlsTabbedPane;
    private javax.swing.JButton _criteriaQueryControlModify_ModifyButton;
    private javax.swing.JButton _criteriaQueryControlModify_RemoveButton;
    private javax.swing.JButton _criteriaQueryControlModify_ResetButton;
    private javax.swing.JPanel _criteriaTabPanel;
    private javax.swing.JButton _criteriaTabQueryControl_ExecuteButton;
    private javax.swing.JPanel _criteriaTabQueryControl_ModifyPanel;
    private javax.swing.JButton _criteriaTabQueryMaker_AndAddButton;
    private javax.swing.JComboBox _criteriaTabQueryMaker_FieldComboBox;
    private javax.swing.JComboBox _criteriaTabQueryMaker_FulfilsComboBox;
    private javax.swing.JLabel _criteriaTabQueryMaker_FulfilsLabel;
    private javax.swing.JButton _criteriaTabQueryMaker_InfoButton;
    private javax.swing.JButton _criteriaTabQueryMaker_OrButton;
    private javax.swing.JComboBox _criteriaTabQueryMaker_ValueComboBox;
    private javax.swing.JTable _criteriaTabQuery_QueryTable;
    private javax.swing.JScrollPane _criteriaTabQuery_QueryTableScrollPane;
    private javax.swing.JPanel _criteriaTab_ControlPanel;
    private javax.swing.JPanel _criteriaTab_QueryMakerPanel;
    private javax.swing.JPanel _criteriaTab_QueryPanel;
    private javax.swing.JButton _drawTabAndOr_AndAddButton;
    private javax.swing.JButton _drawTabAndOr_OrButton;
    private javax.swing.JButton _drawTabControl_RemoveLastLineButton;
    private javax.swing.JButton _drawTabControl_RemoveLastStrokeButton;
    private javax.swing.JButton _drawTabControl_ResetButton;
    private javax.swing.JPanel _drawTabPanel;
    private javax.swing.JButton _drawTabQueryControl_RemoveButton;
    private javax.swing.JButton _drawTabQueryControl_ResetButton;
    private javax.swing.JPanel _drawTab_AndOrPanel;
    private javax.swing.JPanel _drawTab_ControlPanel;
    private javax.swing.JPanel _drawTab_DrawerPanel;
    private javax.swing.JButton _drawTab_ExecuteButton;
    private javax.swing.JPanel _drawTab_QueryControlPanel;
    private javax.swing.JTable _drawTab_QueryTable;
    private javax.swing.JScrollPane _drawTab_QueryTableScrollPane;
    private javax.swing.JComboBox _exportTabAs_FormatComboBox;
    private javax.swing.JLabel _exportTabAs_FormatLabel;
    private javax.swing.JLabel _exportTabAs_Label;
    private javax.swing.JButton _exportTabAs_PathButton;
    private javax.swing.JTextField _exportTabAs_PathTextField;
    private javax.swing.JComboBox _exportTabAs_StyleComboBox;
    private javax.swing.JLabel _exportTabAs_StyleLabel;
    private javax.swing.JButton _exportTabExtra_MoreButton;
    private javax.swing.JButton _exportTabExtra_RearrangeButton;
    private javax.swing.JPanel _exportTabPanel;
    private javax.swing.JButton _exportTabSorting_AddButton;
    private javax.swing.JButton _exportTabSorting_RemoveButton;
    private javax.swing.JButton _exportTabSorting_ResetButton;
    private javax.swing.JScrollPane _exportTabSorting_SortingJScrollPane;
    private javax.swing.JTable _exportTabSorting_SortingTable;
    private javax.swing.JPanel _exportTab_AsPanel;
    private javax.swing.JButton _exportTab_ExportButton;
    private javax.swing.JPanel _exportTab_ExtraPanel;
    private javax.swing.JPanel _exportTab_SortingPanel;
    private javax.swing.JPanel _optionsTabPanel;
    private javax.swing.JButton _optionsTab_AboutButton;
    private javax.swing.JButton _optionsTab_ChangePathLabel;
    private javax.swing.JButton _optionsTab_ChangeStrokesPathLabel;
    private javax.swing.JCheckBox _optionsTab_ExtendedIKanjiListCheckBox;
    private javax.swing.JLabel _optionsTab_ExtendedIKanjiListLabel;
    private javax.swing.JCheckBox _optionsTab_ExtendedInfoCheckBox;
    private javax.swing.JLabel _optionsTab_ExtendedInfoLabel;
    private javax.swing.JCheckBox _optionsTab_KanaToRomajiCheckBox;
    private javax.swing.JLabel _optionsTab_KanaToRomajiLabel;
    private javax.swing.JLabel _optionsTab_KanjiDictPathLabel;
    private javax.swing.JTextField _optionsTab_KanjiDictPathTextField;
    private javax.swing.JComboBox _optionsTab_LanguajeComboBox;
    private javax.swing.JLabel _optionsTab_LanguajeLabel;
    private javax.swing.JButton _optionsTab_SaveButton;
    private javax.swing.JLabel _optionsTab_StrokesPathLabel;
    private javax.swing.JTextField _optionsTab_StrokesPathTextField;
    private javax.swing.JPanel _resultControlPanel;
    private javax.swing.JButton _resultControl_DisposeAllWindowsButton;
    private javax.swing.JPanel _resultExportControlPanel;
    private javax.swing.JButton _resultExportControl_AllButton;
    private javax.swing.JButton _resultExportControl_InvertButton;
    private javax.swing.JButton _resultExportControl_ResetButton;
    private javax.swing.JPanel _resultsPanel;
    private javax.swing.JPanel _results_KanjiGrid;
    // End of variables declaration//GEN-END:variables
	private net.ajaest.lib.swing.panel.JDrawPanel _drawTabDrawer_KanjiDrawPanel;

	// ///////////////////////////////////////////////////////////////
	// ////Getters
	// ///////////////////////////////////////////////////////////////

	public JCheckBox _getOptionsTab_ExtendedIKanjiListCheckBox() {
		return _optionsTab_ExtendedIKanjiListCheckBox;
	}

	public JCheckBox _getOptionsTab_ExtendedInfoCheckBox() {
		return _optionsTab_ExtendedInfoCheckBox;
	}

	public JCheckBox _getOptionsTab_KanaToRomajiCheckBox() {
		return _optionsTab_KanaToRomajiCheckBox;
	}

	public JTextField _getOptionsTab_KanjiDictPathTextField() {
		return _optionsTab_KanjiDictPathTextField;
	}

	public JComboBox _getOptionsTab_LanguajeComboBox() {
		return _optionsTab_LanguajeComboBox;
	}

	public JTextField _getOptionsTab_StrokesPathTextField() {
		return _optionsTab_StrokesPathTextField;
	}
	public JComboBox _getCriteriaTabQueryMaker_FieldComboBox() {
		return _criteriaTabQueryMaker_FieldComboBox;
	}

	public JComboBox _getCriteriaTabQueryMaker_FulfilsComboBox() {
		return _criteriaTabQueryMaker_FulfilsComboBox;
	}

	public JComboBox _getCriteriaTabQueryMaker_ValueComboBox() {
		return _criteriaTabQueryMaker_ValueComboBox;
	}

	public JButton _getCriteriaTabQueryMaker_AndAddButton() {
		return _criteriaTabQueryMaker_AndAddButton;
	}

	public JButton _getCriteriaTabQueryMaker_OrButton() {
		return _criteriaTabQueryMaker_OrButton;
	}

	public JPanel _getResultsPanel() {
		return _resultsPanel;
	}

	public JPanel _getResultExportControlPanel() {

		return _resultExportControlPanel;
	}

	public JPanel _getResultControlPanel() {
		return _resultControlPanel;
	}


	public JPanel _getOptionsTabPanel() {

		return _optionsTabPanel;
	}

	public JTable _getCriteriaTabQuery_QueryTable() {
		return _criteriaTabQuery_QueryTable;
	}

	public JTabbedPane _getControlsTabbedPane() {
		return _controlsTabbedPane;
	}
	public JButton _getDrawTab_ExecuteButton() {
		return _drawTab_ExecuteButton;
	}

	public JPanel _getDrawTab_QueryControlPanel() {
		return _drawTab_QueryControlPanel;
	}

	public JButton _getDrawTabQueryControl_RemoveButton() {
		return _drawTabQueryControl_RemoveButton;
	}

	public JButton _getDrawTabQueryControl_ResetButton() {
		return _drawTabQueryControl_ResetButton;
	}

	public JButton _getCriteriaTabQueryControl_ExecuteButton() {
		return _criteriaTabQueryControl_ExecuteButton;
	}

	public JButton _getCriteriaQueryControlModify_ModifyButton() {
		return _criteriaQueryControlModify_ModifyButton;
	}

	public JButton _getCriteriaQueryControlModify_RemoveButton() {
		return _criteriaQueryControlModify_RemoveButton;
	}

	public JButton _getCriteriaQueryControlModify_ResetButton() {
		return _criteriaQueryControlModify_ResetButton;
	}

	public JTable _getDrawTab_QueryTable() {
		return _drawTab_QueryTable;
	}
	public JButton _getDrawTabAndOr_AndAddButton() {
		return _drawTabAndOr_AndAddButton;
	}

	public JButton _getDrawTabAndOr_OrButton() {
		return _drawTabAndOr_OrButton;
	}

	public JDrawPanel _getDrawTabDrawer_KanjiDrawPanel() {
		return _drawTabDrawer_KanjiDrawPanel;
	}

	public JComboBox _getExportTabAs_FormatComboBox() {
		return _exportTabAs_FormatComboBox;
	}

	public JComboBox _getExportTabAs_StyleComboBox() {
		return _exportTabAs_StyleComboBox;
	}

	public JPanel _getExportTabPanel() {
		return _exportTabPanel;
	}

	public JTextField _getExportTabAs_PathTextField() {
		return _exportTabAs_PathTextField;
	}

	public JTable _getExportTabSorting_SortingTable() {

		return _exportTabSorting_SortingTable;
	}

	public JButton _getCriteriaTabQueryMaker_InfoButton() {

		return _criteriaTabQueryMaker_InfoButton;
	}

	public static void main(String args[]) {

		Launcher.main();
	}

}
